'use strict';
module.exports = {
	up: (queryInterface, Sequelize) => {
		return queryInterface.createTable('Users', {
			id: {
				allowNull: false,
				autoIncrement: true,
				primaryKey: true,
				type: Sequelize.INTEGER
			},
			firstName: {
				type: Sequelize.STRING
			},
			lastName: {
				type: Sequelize.STRING
			},
			email: {
				type: Sequelize.STRING
			},
			// password: {
			// 	type: Sequelize.STRING
			// },
			// phone: {
			// 	type: Sequelize.STRING
			// },
			// status: {
			// 	type: Sequelize.ENUM('active', 'inactive'),
			// 	defaultValue: 'active'
			// },
			// valid: {
			// 	type: Sequelize.INTEGER,
			// 	defaultValue: 0
			// },
			companyId: {
				type: Sequelize.INTEGER,
				allowNull: false,
				references: {
					model: 'Companies',
					key: 'id'
				}
			},
			// isNewUser: {
			// 	type: Sequelize.INTEGER,
			// 	defaultValue: 1
			// },
			// attempt: {
			// 	type: Sequelize.INTEGER,
			// 	defaultValue: 0
			// },
			// otp: {
			// 	type: Sequelize.STRING,
			// 	defaultValue: null
			// },
			// otpExpiry: {
			// 	type: Sequelize.DATE,
			// 	defaultValue: null
			// },
			// verf_key: {
			// 	type: Sequelize.STRING
			// },
			createdAt: {
				allowNull: false,
				type: Sequelize.DATE
			},
			updatedAt: {
				allowNull: false,
				type: Sequelize.DATE
			},
			deletedAt: {
				allowNull: true,
				type: Sequelize.DATE
			},
			// loggedOutAt: {
			// 	type: Sequelize.DATE
			// }
		});
	},
	down: (queryInterface, Sequelize) => {
		return queryInterface.dropTable('Users');
	}
};