'use strict';
module.exports = {
  up: (queryInterface, Sequelize) => {
    return queryInterface.createTable('Employees', {
      id: {
        allowNull: false,
        autoIncrement: true,
        primaryKey: true,
        type: Sequelize.INTEGER
      },
      firstName: {
        type: Sequelize.STRING
      },
      lastName: {
        type: Sequelize.STRING
      },
      email: {
        type: Sequelize.STRING
      },
      password: {
        type: Sequelize.STRING
      },
      phone: {
        type: Sequelize.STRING
      },
      status: {
				type: Sequelize.ENUM('active', 'inactive'),
				defaultValue: 'active'
			},
      valid: {
        type: Sequelize.INTEGER
      },
      attempt: {
        type: Sequelize.INTEGER
      },
      verf_key: {
        type: Sequelize.STRING
      },
      isNewUser: {
        type: Sequelize.INTEGER
      },
      otp: {
				type: Sequelize.STRING,
				defaultValue: null
			},
			otpExpiry: {
				type: Sequelize.DATE,
				defaultValue: null
			},
      companyId: {
        type: Sequelize.INTEGER,
        allowNull: false,
				references: {
					model: 'Companies',
					key: 'id'
				}
      },
      resetPassword:{
        type: Sequelize.INTEGER
      },
      createdAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      updatedAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      deletedAt: {
        allowNull: true,
        type: Sequelize.DATE
      },
			loggedOutAt: {
				type: Sequelize.DATE
			}

    });
  },
  down: (queryInterface, Sequelize) => {
    return queryInterface.dropTable('Employees');
  }
};