'use strict';
module.exports = {
  up: (queryInterface, Sequelize) => {
    return queryInterface.createTable('MetaAuths', {
      id: {
        allowNull: false,
        autoIncrement: true,
        primaryKey: true,
        type: Sequelize.INTEGER
      },
      email: {
        type: Sequelize.STRING
      },
      password: {
        type: Sequelize.STRING
      },
      status: {
        type: Sequelize.INTEGER
      },
      valid: {
        type: Sequelize.INTEGER
      },
      isNewUser: {
        type: Sequelize.INTEGER
      },
      attempt: {
        type: Sequelize.STRING
      },
      otp: {
        type: Sequelize.STRING,
        defaultValue: null
      },
      otpExpiry: {
				type: Sequelize.DATE,
				defaultValue: null
			},
      verf_key: {
        type: Sequelize.STRING
      },
      userId: {
        type: Sequelize.INTEGER
      },
      companyId: {
        type: Sequelize.INTEGER
      },
      memberId: {
        type: Sequelize.INTEGER
      },
      status: {
				type: Sequelize.ENUM('active', 'inactive'),
				defaultValue: 'active'
			},
      loggedOutAt: {
        type: Sequelize.DATE
      },
      createdAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      updatedAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      deletedAt: {
        type: Sequelize.DATE
      }
    });
  },
  down: (queryInterface, Sequelize) => {
    return queryInterface.dropTable('MetaAuths');
  }
};