'use strict';
module.exports = {
  up: (queryInterface, Sequelize) => {
    return queryInterface.createTable('CourseSectionLectures', {
      id: {
        allowNull: false,
        autoIncrement: true,
        primaryKey: true,
        type: Sequelize.INTEGER
      },
      courseSectionId: {
        type: Sequelize.INTEGER,
        references: {
					model: 'CourseSections',
					key: 'id'
				}
      },
      name: {
        type: Sequelize.STRING
      },
      type: {
        type: Sequelize.STRING
      },
      totalDuration: {
        type: Sequelize.INTEGER,
        defaultValue: 0
      },
      storageLocation: {
        type: Sequelize.STRING
      },
      contentId: {
        type: Sequelize.INTEGER
      },
      remoteKey: {
        type: Sequelize.STRING
      },
      createdAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      updatedAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      deletedAt: {
        allowNull: true,
				type: Sequelize.DATE
			},
    });
  },
  down: (queryInterface, Sequelize) => {
    return queryInterface.dropTable('CourseSectionLectures');
  }
};