'use strict';
module.exports = {
  up: (queryInterface, Sequelize) => {
    return queryInterface.createTable('Simulations', {
      id: {
        allowNull: false,
        autoIncrement: true,
        primaryKey: true,
        type: Sequelize.INTEGER
      },
      campaignId: {
        type: Sequelize.INTEGER,
        allowNull: false,
				references: {
					model: 'Campaigns',
					key: 'id'
				}
      },
      type: {
        type: Sequelize.STRING
      },
      scheduledId: {
        allowNull: true,
				type: Sequelize.INTEGER,
			},
			scheduledAt: {
        allowNull: true,
				type: Sequelize.DATE
			},
			launchedAt: {
        allowNull: true,
				type: Sequelize.DATE
			},
      createdAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      updatedAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      deletedAt: {
        allowNull: true,
				type: Sequelize.DATE
			},
    });
  },
  down: (queryInterface, Sequelize) => {
    return queryInterface.dropTable('Simulations');
  }
};