'use strict';
module.exports = {
  up: (queryInterface, Sequelize) => {
    return queryInterface.createTable('MemberCourses', {
      id: {
        allowNull: false,
        autoIncrement: true,
        primaryKey: true,
        type: Sequelize.INTEGER
      },
      courseId: {
        type: Sequelize.INTEGER,
        allowNull: false,
				references: {
					model: 'Courses',
					key: 'id'
				}
      },
      sessionId: {
        type: Sequelize.INTEGER,
        allowNull: false,
				references: {
					model: 'Sessions',
					key: 'id'
				}
      },
      memberId: {
        type: Sequelize.INTEGER,
        allowNull: false,
				references: {
					model: 'Members',
					key: 'id'
				}
      },
      percent: {
       type: Sequelize.DECIMAL(10,2)
      },
      createdAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      updatedAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      deletedAt: {
        type: Sequelize.DATE
      }
    });
  },
  down: (queryInterface, Sequelize) => {
    return queryInterface.dropTable('MemberCourses');
  }
};