'use strict';
module.exports = {
  up: (queryInterface, Sequelize) => {
    return queryInterface.createTable('SimulationReminders', {
      id: {
        allowNull: false,
        autoIncrement: true,
        primaryKey: true,
        type: Sequelize.INTEGER
      },
      simulationId: {
        type: Sequelize.INTEGER,
        allowNull: false,
        references: {
					model: 'Simulations',
					key: 'id'
				}
      },
      campaignCourseId: {
        type: Sequelize.INTEGER,
        references: {
					model: 'CampaignCourses',
					key: 'id'
				}
      },
      campaignQuizId: {
        type: Sequelize.INTEGER,
        references: {
					model: 'CampaignQuizzes',
					key: 'id'
				}
      },
      type: {
        type: Sequelize.STRING
      },
      percent: {
        type: Sequelize.INTEGER,
        defaultValue: 0
      },
      scheduledAt: {
        allowNull: true,
        type: Sequelize.DATE
      },
      executedAt: {
        type: Sequelize.DATE,
        allowNull: true,
      },
      createdAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      updatedAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      deletedAt: {
        allowNull: true,
        type: Sequelize.DATE
      }
    });
  },
  down: (queryInterface, Sequelize) => {
    return queryInterface.dropTable('SimulationReminders');
  }
};