'use strict';
module.exports = {
  up: (queryInterface, Sequelize) => {
    return queryInterface.createTable('CourseLectureQuestions', {
      id: {
        allowNull: false,
        autoIncrement: true,
        primaryKey: true,
        type: Sequelize.INTEGER
      },
      courseSectionLectureId: {
        type: Sequelize.INTEGER,
        allowNull: false,
				references: {
					model: 'CourseSectionLectures',
					key: 'id'
				}
      },
      courseQuizQuestionId: {
        type: Sequelize.INTEGER,
        allowNull: false,
				references: {
					model: 'CourseQuizQuestions',
					key: 'id'
				}
      },
      createdAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      updatedAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      deletedAt: {
        allowNull: true,
				type: Sequelize.DATE
			}
    });
  },
  down: (queryInterface, Sequelize) => {
    return queryInterface.dropTable('CourseLectureQuestions');
  }
};