'use strict';
module.exports = {
  up: (queryInterface, Sequelize) => {
    return queryInterface.createTable('CourseUserQuizDetails', {
      id: {
        allowNull: false,
        autoIncrement: true,
        primaryKey: true,
        type: Sequelize.INTEGER
      },
      courseSectionLectureId: {
        type: Sequelize.INTEGER,
        allowNull: false,
				references: {
					model: 'CourseSectionLectures',
					key: 'id'
				}
      },
      sessionId: {
        type: Sequelize.INTEGER,
        allowNull: false,
				references: {
					model: 'Sessions',
					key: 'id'
				}
      },
      attempts: {
        type: Sequelize.INTEGER
      },
      percent: {
        type: Sequelize.DECIMAL(10,2)
      },
      status: {
        type: Sequelize.INTEGER,
        defaultValue: 1
      },
      maxMarks: {
        type: Sequelize.INTEGER,
        defaultValue: 0
      },
      obtainedMarks: {
        type: Sequelize.INTEGER,
        defaultValue: 0
      },
      createdAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      updatedAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      deletedAt: {
        allowNull: true,
				type: Sequelize.DATE
			}
    });
  },
  down: (queryInterface, Sequelize) => {
    return queryInterface.dropTable('CourseUserQuizDetails');
  }
};