'use strict';
module.exports = {
  up: (queryInterface, Sequelize) => {
    return queryInterface.createTable('Senders', {
      id: {
        allowNull: false,
        autoIncrement: true,
        primaryKey: true,
        type: Sequelize.INTEGER
      },
      companyId: {
        type: Sequelize.INTEGER,
        references: {
					model: 'Companies',
					key: 'id'
				}
      },
      name: {
        type: Sequelize.STRING
      },
      fromAddress: {
        type: Sequelize.STRING
      },
      host: {
        type: Sequelize.STRING
      },
      username: {
        type: Sequelize.TEXT
      },
      password: {
        type: Sequelize.STRING
      },
      status: {
				type: Sequelize.ENUM('active', 'inactive'),
				defaultValue: 'active'
      },
      ignore_cert_errors: {
				type: Sequelize.INTEGER,
				length: 1,
				notEmpty: true
      },
      pool: {
				type: Sequelize.BOOLEAN
      },
      connectionTimeout: {
				type: Sequelize.INTEGER
      },
      ssl: {
				type: Sequelize.BOOLEAN
      },
      maxConnections: {
				type: Sequelize.INTEGER
      },
      maxMessages: {
				type: Sequelize.INTEGER
      },
      limit: {
				type: Sequelize.INTEGER
      },
      delay: {
				type: Sequelize.INTEGER
      },
      createdAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      updatedAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      deletedAt: {
        allowNull: true,
        type: Sequelize.DATE
      }
    });
  },
  down: (queryInterface, Sequelize) => {
    return queryInterface.dropTable('Senders');
  }
};