'use strict';

module.exports = {
  up: (queryInterface, Sequelize) => {
    return Promise.all([
      queryInterface.addColumn(
        'Members',
        'code', {
          type: Sequelize.TEXT,
          allowNull: false,
        },
      ), 
      queryInterface.addColumn(
        'Members',
        'courseMails', {
          type: Sequelize.BOOLEAN,
          defaultValue: 1
        },
      ),
      queryInterface.addColumn(
        'Members',
        'assessmentMails', {
          type: Sequelize.BOOLEAN,
          defaultValue: 1
        },
      ),
      queryInterface.addColumn(
        'Members',
        'reminderMails', {
          type: Sequelize.BOOLEAN,
          defaultValue: 1
        },
      ),
      queryInterface.addColumn(
        'Members',
        'announcementMails', {
          type: Sequelize.BOOLEAN,
          defaultValue: 1
        },
      ),
    ]);
  },

  down: (queryInterface, Sequelize) => {
    return Promise.all([
      queryInterface.removeColumn(
        'Members',
        'code'
      ),
      queryInterface.removeColumn(
        'Members',
        'courseMails'
      ),
      queryInterface.removeColumn(
        'Members',
        'assessmentMails'
      ),
      queryInterface.removeColumn(
        'Members',
        'reminderMails'
      ), 
      queryInterface.removeColumn(
        'Members',
        'announcementMails'
      ),
    ]);
  }
};
