import express from 'express';
import campaignController from './campaign.controller';
import { sanitize } from '../../../middleware/sanitizer';
import { jwtStrategy } from '../../../middleware/strategy';
import { userPermission } from '../../../middleware/userPermission';

export const campaignRouter = express.Router();

campaignRouter.route('/list').get(sanitize(), jwtStrategy ,userPermission('campaign-list'), campaignController.list);
campaignRouter.route('/result').get(sanitize(), jwtStrategy ,userPermission('campaign-result-read'), campaignController.result);
campaignRouter.route('/error-result').get(sanitize(), jwtStrategy ,userPermission('campaign-result-read'), campaignController.errorResult);
campaignRouter.route('/resultCount').get(sanitize(), jwtStrategy , userPermission('campaign-result-read'),campaignController.resultCount);
campaignRouter.route('/course-list').get(sanitize(), jwtStrategy ,userPermission('campaign-list'), campaignController.courseList);
campaignRouter.route('/quiz-list').get(sanitize(), jwtStrategy ,userPermission('campaign-list'), campaignController.quizList);
campaignRouter.route('/:id').delete(jwtStrategy,userPermission('campaign-delete'), campaignController.delete);
campaignRouter.route('/').delete(jwtStrategy,userPermission('campaign-delete'),campaignController.deleteAll);
campaignRouter.route('/fetch-error/:id').get(jwtStrategy, userPermission('campaign-fetch-error'), campaignController.fetcherror);
