import express from 'express';
import resultController from './result.controller';
import { sanitize } from '../../../middleware/sanitizer';
import { jwtStrategy } from '../../../middleware/strategy'
import { userPermission } from '../../../middleware/userPermission'
export const resultRouter = express.Router();
const rateLimit = require("express-rate-limit");
const apiLimiter = rateLimit({
    windowMs: 1 * 60 * 1000, // 15 minutes
    max: 50, 
    message: "Too many accounts created from this IP, please try again after an hour"
  });
resultRouter.route('/').get(sanitize(),apiLimiter, jwtStrategy, userPermission('report-read'),resultController.index);
resultRouter.route('/user-list').get(sanitize(),apiLimiter, jwtStrategy, userPermission('report-list'),resultController.fetch);
