const Cryptr = require('cryptr');
var sha1 = require('sha1');
import config from './config'

export var randomString = (len, charSet) => {
    charSet = charSet || 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    var randomString = '';
    for (var i = 0; i < len; i++) {
        var randomPoz = Math.floor(Math.random() * charSet.length);
        randomString += charSet.substring(randomPoz, randomPoz + 1);
    }
    return randomString;
}

export function addedHis(str){
    return str+" 00:00:00";
}

export var differentDateFormat  = function(f, t){
    var today = (t != undefined ? new Date(t) : new Date());
    var dd = today.getDate();
    var mm = today.getMonth()+1; 
    var yyyy = today.getFullYear();
    if(dd<10) dd='0'+dd;
    if(mm<10) mm='0'+mm;
    if(f == 1) today = mm+'-'+dd+'-'+yyyy;
    if(f == 2) today = mm+'/'+dd+'/'+yyyy;
    if(f == 3) today = dd+'-'+mm+'-'+yyyy;
    if(f == 4) today = dd+'/'+mm+'/'+yyyy;
    if(f == 5) today = yyyy+'-'+mm+'-'+dd;
    return today;
}

export var validateEmail = function (email) {
    var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(String(email).toLowerCase());
}

export function secondsToTime(secs) {
    var hours = Math.floor(secs / (60 * 60));

    var divisor_for_minutes = secs % (60 * 60);
    var minutes = Math.floor(divisor_for_minutes / 60);

    var divisor_for_seconds = divisor_for_minutes % 60;
    var seconds = Math.ceil(divisor_for_seconds);

    return hours.pad() + ":" + minutes.pad() + ":" + seconds.pad();
}

export function capitalizeFirstLetter(string) {
    return string.charAt(0).toUpperCase() + string.slice(1);
}

export function getDomainName(hostname) {
    var domain = hostname;
    if (hostname != null) {
        var parts = hostname.split('.').reverse();

        if (parts != null && parts.length > 1) {
            domain = parts[1] + '.' + parts[0];

            if (hostname.toLowerCase().indexOf('.co.uk') != -1 && parts.length > 2) {
                domain = parts[2] + '.' + domain;
            }
        }
    }
    return domain;
}

export function CheckIsValidDomain(domain) { 
	var re = new RegExp(/^((?:(?:(?:\w[\.\-\+]?)*)\w)+)((?:(?:(?:\w[\.\-\+]?){0,62})\w)+)\.(\w{2,6})$/); 
	return domain.match(re);
} 

global.json = (obj) => {
    return JSON.parse(JSON.stringify(obj))
}

export function generateQueryString(data) {
    let keys = Object.keys(data);
    let values = [];
    for (var i = 0; i < keys.length; i++) {
        values.push(keys[i] + '=' + data[keys[i]]);
    }
    return values.join('&');
}

global.encrypt = (data) => {
    const cryptr = new Cryptr(config.app.secret);
    return cryptr.encrypt(data);
}

global.decrypt = (data) => {
    const cryptr = new Cryptr(config.app.secret);
    return cryptr.decrypt(data);
}

export function makenumerickey() {
    var text = "";
    var possible = "0123456789";
    for (var i = 0; i < 7; i++)
      text += possible.charAt(Math.floor(Math.random() * possible.length));
    return text;
}
export function makealphakey(){
    var text = "";
    var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
    for (var i = 0; i < 7; i++)
      text += possible.charAt(Math.floor(Math.random() * possible.length));
    return text;
}

export function createChecksum(callName, parameters){
    var checksum = sha1(callName+parameters+config.bigblue.secret_key);
    return checksum;
}

export function sanitize(input) {
    return input.replace(/<(|\/|[^>\/bi]|\/[^>bi]|[^\/>][^>]+|\/[^>][^>]+)>/g, '');
}