import { db } from '../models';
import config from '../config';
import sessionData from './session';

var makeid = () => {
    var text = "";
    var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
    for (var i = 0; i < 40; i++)
        text += possible.charAt(Math.floor(Math.random() * possible.length));
    return text;
}

process.on('message', async (data) => {
    sessionData.createSessions(data.simulationId, data.groups, data.companyId, data.status, data.isManager, data.type)
    .then(r => {
        process.send({  error: false })
    })
    .catch(e => {
        process.send({ error: true })
    })
});

var sessions = (resultData) => {
    return db.Session.bulkCreate(resultData, {returning: true})
    .then(result => {
        return true;
    })
    .catch(err => {
        console.log(JSON.stringify(err));
        return true;
    })
}

export default {
    createSessions: async (simulationId, groups, companyId, status, isManager, type) => {         
        var memberCourses = [], isManage = (isManager == 'yes' ? 1 : 0);
        var members = {}, count = 1, batching = config.mail.batching;
        return new Promise((resolve, reject) => {
            return groups.reduce((p, data) => {
                if(data.memberId){
                    if(data.isManager == 0 && isManage != 0)
                        data.isManager = 1;
                    if(!members[count]) members[count] = [];
                    if(isManage  == data.isManager){
                        var rId = makeid();
                        if(data.Member.email && !memberCourses.includes(data.Member.email)){
                            status = (type == 'course' ? (data.Member.courseMails ? status : 'Unsubscribed'): (data.Member.assessmentMails ? status : 'Unsubscribed'));
                            members[count].push({ companyId: companyId, simulationId: simulationId, sessionKey: rId, memberId: data.memberId, groupId: data.groupId, firstName: data.Member.firstName, lastName: data.Member.lastName, email: data.Member.email, phone: data.Member.phone, status: status? status: 'Pending' });
                            memberCourses.push(data.Member.email);
                        }
                        if(members[count].length%batching == 0){
                            return sessions(members[count++]);
                        }
                    }
                }else{
                    console.log('Invalid Members');
                }
            }, Promise.resolve(resolve(true)));
        })
        .then(r => {
            if(members && members[count] && members[count].length%batching != 0) return sessions(members[count]);
            else return true;
        })
        .catch(err => console.log(err))
    }
}