import { db } from '../models'
import config from '../config'
import { capitalizeFirstLetter } from './../functions';
const _ = require('lodash'); 

var imageTemp = (result, mainUrl, filename, type, notracker) => {
    try {
        var html = '';
        for(var i = 0; i < result.courseOrQuiz.length; i++)
            html = '<!DOCTYPE html> <html> <head> <title></title> </head> <body> <p>&nbsp;</p> <div style="width:500px; margin-top:0; margin-bottom:0; margin-left:auto; margin-right:auto; box-shadow: 0px 0px 2px grey;"><a href="'+mainUrl+'/course-auth?rmId='+encrypt(result.courseOrQuiz[i].id)+'&t='+(type == 'course' ? '1' : '2')+'&sKey='+result.sessionKey+'"><img src="cid:'+filename+'" style="width: 100%; height: auto;border: 1px solid #efefef;" /></a></div>  '+(notracker ? '<p><img alt="" border="0" height="1" src="' +mainUrl+'/tracker?sId='+result.sessionKey + '" style="height:1px!important;width:1px!important;border-width:0!important;margin-top:0!important;margin-bottom:0!important;margin-right:0!important;margin-left:0!important;padding-top:0!important;padding-bottom:0!important;padding-right:0!important;padding-left:0!important" width="1"></p>': '' )+' </body> </html>';
        return html;
    } catch (err) {
        console.log('conversion fail', err)
        return '';   
    }
}

export default {

    courseCertificateTemplateHtml: (template,result, data) => {
        try {
            var mainUrl = (data.MetaData && data.MetaData.length > 0 ? data.MetaData[0].value : config.app.url);
            var html = template.html;
            html = html.replace(new RegExp('{{.logo}}', "gi"), mainUrl+'/static/'+(data.logo && data.logo != '' ? 'company/logo/'+data.logo : 'images/lms-logo.png') );
            html = html.replace(new RegExp('{{.star}}', "gi"), mainUrl+'/static/images/star.png');
            html = html.replace(new RegExp('{{.ribbon}}', "gi"), mainUrl+'/static/images/ribbon.png');
            html = html.replace(new RegExp('{{.name}}', "gi"), result?capitalizeFirstLetter(result.Member.firstName)+(result.Member.lastName != null ?' '+capitalizeFirstLetter(result.Member.lastName) : ''):'');
            html = html.replace(new RegExp('{{.course}}', "gi"), capitalizeFirstLetter(result.Course.name));
            html = html.replace(new RegExp('{{.completedDate}}', "gi"), result?result.completedAt:'');
            html = html.replace(new RegExp('{{.certificateNo}}', "gi"), result?result.certificateNo:'');
            return html;
        } catch (err) {
            console.log('conversion fail', err)
            return template.html;
        }
    },

    assessmentCertificateTemplateHtml: (template,result, data) => {
        try {
            var mainUrl = (data.MetaData && data.MetaData.length > 0 ? data.MetaData[0].value : config.app.url);
            var html = template.html;
            html = html.replace(new RegExp('{{.logo}}', "gi"), mainUrl+'/static/'+(data.logo && data.logo != '' ? 'company/logo/'+data.logo : 'images/lms-logo.png'));
            html = html.replace(new RegExp('{{.star}}', "gi"), mainUrl+'/static/images/star.png');
            html = html.replace(new RegExp('{{.ribbon}}', "gi"), mainUrl+'/static/images/ribbon-orange.png');
            html = html.replace(new RegExp('{{.name}}', "gi"), result?capitalizeFirstLetter(result.Member.firstName)+(result.Member.lastName != null ?' '+capitalizeFirstLetter(result.Member.lastName) : ''):'');
            html = html.replace(new RegExp('{{.assessment}}', "gi"), capitalizeFirstLetter(result.Quiz.name));
            html = html.replace(new RegExp('{{.completedDate}}', "gi"), result?result.completedAt:'');
            html = html.replace(new RegExp('{{.certificateNo}}', "gi"), result?result.certificateNo:'');
            return html;
        } catch (err) {
            console.log('conversion fail', err)
            return template.html;
        }
    },
    generateTemplateHtml: (result, template, data, companyId, metadata) => { //done
        try {
            var mainUrl = (data.MetaData && data.MetaData.length > 0 ? data.MetaData[0].value : config.app.url);
            if(metadata !='' && metadata.enable && metadata.type == 'image' && !(_.isEmpty(metadata.filename))){
                return imageTemp(result, mainUrl, metadata.filename, result.type, true);
            }else{
                var html = template.html;
                var anyOneTemplate = '';
                var extracontent = '';
                if(result.courseOrQuiz && result.courseOrQuiz.length > 0){
                    if(result.type == 'course'){
                        for(var i = 0; i < result.courseOrQuiz.length; i++){
                            anyOneTemplate += '<tr style="text-align: center;"> <td width="40%" > <img src="cid:'+(result.courseOrQuiz[i] ? result.courseOrQuiz[i].image : '')+'" width="240" height="156"> </td> <td width="60%"  style="display:block;width:100%;line-height: 20px;height: 156px;float: right;background: #fedab0;"> <div style="text-align:center;"><p style="color:#000; padding: 0px 10px;font-family:Arial; text-decoration: none; font-size: 16px; font-weight: 600;">'+(result.courseOrQuiz[i] ? result.courseOrQuiz[i].name : '')+'</p><br><center><!--[if mso]> <v:roundrect xmlns:v="urn:schemas-microsoft-com:vml" xmlns:w="urn:schemas-microsoft-com:office:word" href="'+mainUrl+'/course-auth?rmId='+encrypt(result.courseOrQuiz[i].id)+'&t=1&sKey='+result.sessionKey+'" style="height:40px;v-text-anchor:middle;width:155px;" arcsize="5%" strokecolor="#f0803b" fillcolor="#f0803b"> <w:anchorlock/> <center style="color:#fff;font-family:Helvetica, Arial,sans-serif;font-size:16px;">Start Course</center> </v:roundrect> <![endif]--></center> <center><a href="'+mainUrl+'/course-auth?rmId='+encrypt(result.courseOrQuiz[i].id)+'&t=1&sKey='+result.sessionKey+'" style="background-color:#f0803b;border:1px solid #f0803b;border-radius:3px;color:#fff;display:inline-block;font-family:sans-serif;font-size:16px;line-height:35px;text-align:center;text-decoration:none;width:115px;-webkit-text-size-adjust:none;mso-hide:all;font-size: 16px;">Start Course</a></center>  </div> </td> </tr>';
                            if(companyId == 132)
                                extracontent = '<p style="font-size: 16px;line-height: 25px;font-family:Arial;color:#4a4848;margin-bottom: 13px;margin-top: 8px;padding: 0px 40px;">As part of Company’s Phishing exercise, few days back phishing e-mail was sent to you.</p><p style="font-size: 16px;line-height: 25px;font-family:Arial;color:#4a4848;margin-bottom: 13px;margin-top: 8px;padding: 0px 40px;">It was noticed that you have clicked on the phishing web site and entered the Company’s Email Address. As part of knowledge enhancement activity, this mail is sent to you.</p><p style="font-size:16px;line-height: 25px;font-family:Arial;color:#4a4848;margin-bottom:20px;margin-top: 9px;    padding: 0px 40px;">You are requested to complete this activity latest by end of business hours of 5th February 2021 by clicking on <b>Start Course</b> button.</p><p style="font-size:16px;line-height: 25px;font-family:Arial;color:#4a4848;margin-bottom:20px;margin-top: 9px;padding: 0px 40px;"><b>Note:</b> If the video is not supported by your browser, copy the link  and paste it into Chrome Browser to access it.</p>';
                        }
                    }else{
                        for(var i = 0; i < result.courseOrQuiz.length; i++){
                            anyOneTemplate += '<tr style="text-align: center;"> <td width="40%"> <img src="cid:'+(result.courseOrQuiz[i] ? result.courseOrQuiz[i].image : '')+'" width="240" height="156"> </td> <td width="60%"  style="display:block;width:100%;  line-height: 20px;height: 156px;float: right;background: #fedab0;"> <div style="text-align:center;"><p style="color:#000; padding: 0px 10px;font-family:Arial; text-decoration: none; font-size: 16px; font-weight: 600;">'+(result.courseOrQuiz[i] ? result.courseOrQuiz[i].name : '')+'</p><br><center><!--[if mso]> <v:roundrect xmlns:v="urn:schemas-microsoft-com:vml" xmlns:w="urn:schemas-microsoft-com:office:word" href="'+mainUrl+'/course-auth?rmId='+encrypt(result.courseOrQuiz[i].id)+'&t=2&sKey='+result.sessionKey+'" style="height:40px;v-text-anchor:middle;width:155px;" arcsize="5%" strokecolor="#f0803b" fillcolor="#f0803b"> <w:anchorlock/> <center style="color:#fff;font-family:Helvetica, Arial,sans-serif;font-size:16px;">Start Test</center> </v:roundrect> <![endif]--></center> <center><a href="'+mainUrl+'/course-auth?rmId='+encrypt(result.courseOrQuiz[i].id)+'&t=2&sKey='+result.sessionKey+'" style="background-color:#f0803b;border:1px solid #f0803b;border-radius:3px;color:#fff;display:inline-block;font-family:sans-serif;font-size:16px;line-height:35px;text-align:center;text-decoration:none;width:115px;-webkit-text-size-adjust:none;mso-hide:all;font-size: 16px;">Start Test</a></center></div> </td> </tr>';
                            if(companyId == 132)
                                extracontent = '<p style="font-size: 16px;line-height: 25px;font-family:Arial;color:#4a4848;margin-bottom: 13px;margin-top: 8px;padding: 0px 40px;">As part of Company’s Phishing exercise, few days back phishing e-mail was sent to you.</p><p style="font-size: 16px;line-height: 25px;font-family:Arial;color:#4a4848;margin-bottom: 13px;margin-top: 8px;padding: 0px 40px;">It was noticed that you have clicked on the phishing web site and entered the Company’s Email Address. As part of knowledge enhancement activity, this mail is sent to you.</p><p style="font-size:16px;line-height: 25px;font-family:Arial;color:#4a4848;margin-bottom:20px;margin-top: 9px;    padding: 0px 40px;">You are requested to complete this activity latest by end of business hours of 5th February 2021 by clicking on <b>Start Course</b> button.</p><p style="font-size:16px;line-height: 25px;font-family:Arial;color:#4a4848;margin-bottom:20px;margin-top: 9px;padding: 0px 40px;"><b>Note:</b> If the video is not supported by your browser, copy the link  and paste it into Chrome Browser to access it.</p>';
                        }
                    } 
                }
                html = html.replace(new RegExp('{{.logo}}', "gi"), (data.logo && data.logo != '' ? 'cid:'+data.logo : 'cid:lms-logo.png'));
                html = html.replace(new RegExp('{{.firstName}}', "gi"), result?capitalizeFirstLetter(result.firstName):'');
                html = html.replace(new RegExp('{{.lastName}}', "gi"), result?(result.lastName ? ' '+capitalizeFirstLetter(result.lastName) : ''):'');
                html = html.replace(new RegExp('{{.courses}}', "gi"), anyOneTemplate);
                html = html.replace(new RegExp('{{.upper_content}}', "gi"), (metadata !='' && metadata.enable ? metadata.upper_content : (result.type == 'course' ? 'You have been enrolled in the below course by the Administrator' : 'You have received an assessment')));
                html = html.replace(new RegExp('{{.extralink}}', "gi"), (metadata != '' && metadata.enable && metadata.middle_content ? '<div style="font-size: 16px;line-height: 25px;font-family:Arial;color:#4a4848;margin-bottom: 13px;margin-top: 8px;text-align:left;padding:0px 20px;">'+metadata.middle_content+'</div>' : extracontent));
                html = html.replace(new RegExp('{{.lower_content}}', "gi"), (metadata !='' && metadata.enable ? metadata.lower_content : 'Regards,'));
                html = html.replace(new RegExp('{{.unsubscribe}}', "gi"), '');
                // html = html.replace(new RegExp('{{.unsubscribe}}', "gi"), ((companyId == 57 || companyId == 260) ? '' : '<p style="text-align:center;line-height:26px">Not interested in receiving this type of mail?<br> Update subscription preferences: <a href="'+mainUrl+'/unsubscribe?unsubscribe_code='+result.code+'&mId=RXertMZt">Unsubscribe</a></p>') );
                html = html.replace(new RegExp('{{.companyName}}', "gi"), (data.name && data.name != '' ? data.name : 'Krademy LMS') );
                html = html.replace(new RegExp('{{.tracker}}', "gi"), '<img alt="" border="0" height="1" src="' +mainUrl+'/tracker?sId='+result.sessionKey + '" style="height:1px!important;width:1px!important;border-width:0!important;margin-top:0!important;margin-bottom:0!important;margin-right:0!important;margin-left:0!important;padding-top:0!important;padding-bottom:0!important;padding-right:0!important;padding-left:0!important" width="1">');
                return html;
            }
        } catch (err) {
            console.log('conversion fail', err)
            return template.html;   
        }
    },

    generateTemplateForCourseQuizFails: (result, template, data, metadata) => {
        try {
            var mainUrl = (data.MetaData && data.MetaData.length > 0 ? data.MetaData[0].value : config.app.url);
            if(metadata !='' && metadata.enable && metadata.type == 'image' && !(_.isEmpty(metadata.filename)) ){
                return imageTemp(result, mainUrl, metadata.filename, 'course', false);
            }else{
                var html = template.html;
                var anyOneTemplate = '';
                var extracontent = '';
                if(result.courseOrQuiz && result.courseOrQuiz.length > 0){
                    for(var i = 0; i < result.courseOrQuiz.length; i++)
                        anyOneTemplate += '<tr style="text-align: center;"> <td width="40%"> <img src="cid:'+(result.courseOrQuiz[i] ? result.courseOrQuiz[i].image : '')+'" width="240" height="156"> </td> <td width="60%" style="display:block;width:100%;line-height: 20px;height: 156px;float: right;background: #fedab0;"> <div style="text-align:center;"><p style="color:#000; padding: 0px 10px;font-family:Arial; text-decoration: none; font-size: 16px; font-weight: 600;">'+(result.courseOrQuiz[i] ? result.courseOrQuiz[i].name : '')+'</p><br><center><!--[if mso]> <v:roundrect xmlns:v="urn:schemas-microsoft-com:vml" xmlns:w="urn:schemas-microsoft-com:office:word" href="'+mainUrl+'/course-auth?rmId='+encrypt(result.courseOrQuiz[i].id)+'&t=1&sKey='+result.sessionKey+'" style="height:40px;v-text-anchor:middle;width:155px;" arcsize="5%" strokecolor="#f0803b" fillcolor="#f0803b"> <w:anchorlock/> <center style="color:#fff;font-family:Helvetica, Arial,sans-serif;font-size:16px;">Start Test</center> </v:roundrect> <![endif]--></center>  <center><a href="'+mainUrl+'/course-auth?rmId='+encrypt(result.courseOrQuiz[i].id)+'&t=1&sKey='+result.sessionKey+'" style="background-color:#f0803b;border:1px solid #f0803b;border-radius:3px;color:#fff;display:inline-block;font-family:sans-serif;font-size:16px;line-height:35px;text-align:center;text-decoration:none;width:115px;-webkit-text-size-adjust:none;mso-hide:all;font-size: 16px;">Restart Quiz</a></center> </div> </td> </tr>';
                }
                html = html.replace(new RegExp('{{.logo}}', "gi"), (data.logo && data.logo != '' ? 'cid:'+data.logo : 'cid:lms-logo.png'));
                html = html.replace(new RegExp('{{.firstName}}', "gi"), result?capitalizeFirstLetter(result.firstName):'');
                html = html.replace(new RegExp('{{.lastName}}', "gi"), result?(result.lastName ? ' '+capitalizeFirstLetter(result.lastName) : ''):'');
                html = html.replace(new RegExp('{{.courses}}', "gi"), anyOneTemplate);
                html = html.replace(new RegExp('{{.upper_content}}', "gi"), (metadata !='' && metadata.enable ? metadata.upper_content : 'Unfortunately, you failed a quiz attempt of the below course.'));
                html = html.replace(new RegExp('{{.extralink}}', "gi"), (metadata != '' && metadata.enable && metadata.middle_content ? '<div style="font-size: 16px;line-height: 25px;font-family:Arial;color:#4a4848;margin-bottom: 13px;margin-top: 8px;padding: 0px 20px;text-align:left;">'+metadata.middle_content+'</div>' : extracontent));
                html = html.replace(new RegExp('{{.lower_content}}', "gi"), (metadata !='' && metadata.enable ? metadata.lower_content : 'Regards,'));
                html = html.replace(new RegExp('{{.unsubscribe}}', "gi"), '');
                // html = html.replace(new RegExp('{{.unsubscribe}}', "gi"), (data && (data.companyId == 57 || data.companyId == 260) ? '' : '<p style="text-align:center;line-height:26px">Not interested in receiving this type of mail?<br> Update subscription preferences: <a href="'+mainUrl+'/unsubscribe?unsubscribe_code='+result.code+'&mId=RXertMZt">Unsubscribe</a></p>') );
                html = html.replace(new RegExp('{{.companyName}}', "gi"), (data.name && data.name != '' ? data.name : 'Krademy LMS') );
                return html;
            }
        } catch (err) {
            console.log('conversion fail', err)
            return template.html;   
        }
    },

    generateCourseReminderHtml: (result, template, data, metadata) => { // done
        try {
            var mainUrl = (data.MetaData && data.MetaData.length > 0 ? data.MetaData[0].value : config.app.url);
            if(metadata !='' && metadata.enable && metadata.type == 'image' && !(_.isEmpty(metadata.filename)) ){
                var html = '<!DOCTYPE html> <html> <head> <title></title> </head> <body> <p>&nbsp;</p> <div style="width:500px; margin-top:0; margin-bottom:0; margin-left:auto; margin-right:auto; box-shadow: 0px 0px 2px grey;"><a href="'+mainUrl+'/course-auth?rmId='+encrypt(result.courseId)+'&t=1&sKey='+result.sessionKey+'"><img src="cid:'+metadata.filename+'" style="width: 100%; height: auto;border: 1px solid #efefef;" /></a></div> </body> </html>';
                return html;
            }else{
                var html = template.html;
                var str = '<td style="text-align: center;"> <p style="border-top: 2px solid #fedab0; margin-top: 0px;"></p> <div style="font-size:16px; line-height:26px;font-family:Arial;margin-bottom:20px;color: #4a4848;padding:0px 20px;text-align:left;">'+(metadata != '' && metadata.enable && metadata.middle_content ? metadata.middle_content : '')+'</div> <p style="font-size:16px; line-height:20px;font-family:Arial;margin-bottom:25px;color:black;">Click below to '+(result.percent == 0 ? 'begin' : 'continue')+' the course</p><center><!--[if mso]> <v:roundrect xmlns:v="urn:schemas-microsoft-com:vml" xmlns:w="urn:schemas-microsoft-com:office:word" href="'+(result ? mainUrl+result.url+'rmId='+encrypt(result.courseId)+'&t=1&sKey='+result.sessionKey : mainUrl+'/my-courses')+'" style="height:40px;v-text-anchor:middle;width:155px;" arcsize="5%" strokecolor="#f0803b" fillcolor="#f0803b"> <w:anchorlock/> <center style="color:#fff;font-family:Helvetica, Arial,sans-serif;font-size:16px;">'+(result.percent == 0 ? 'Start' : 'Resume')+' Course</center> </v:roundrect> <![endif]--></center><center><a style="background: #f0803b; color:white; padding: 10px 20px;font-family:Arial; text-decoration: none; border-radius:4px; letter-spacing: 0.3px;font-size: 16px;-webkit-text-size-adjust:none;mso-hide:all; font-weight: 600;" href="'+(result ? mainUrl+result.url+'rmId='+encrypt(result.courseId)+'&t=1&sKey='+result.sessionKey : mainUrl+'/my-courses')+'" target="_blank">'+(result.percent == 0 ? 'Start' : 'Resume')+' Course</a></center> </td>';
                html = html.replace(new RegExp('{{.logo}}', "gi"), (data.logo && data.logo != '' ? 'cid:'+data.logo : 'cid:lms-logo.png'));
                html = html.replace(new RegExp('{{.firstName}}', "gi"), result?capitalizeFirstLetter(result.firstName):'');
                html = html.replace(new RegExp('{{.lastName}}', "gi"), result?(result.lastName ? ' '+capitalizeFirstLetter(result.lastName) : ''):'');
                html = html.replace(new RegExp('{{.courseName}}', "gi"), result?result.courseName:'');
                html = html.replace(new RegExp('{{.content}}', "gi"), str);
                html = html.replace(new RegExp('{{.upper_content}}', "gi"), (metadata !='' && metadata.enable ? metadata.upper_content : 'A soft reminder for your assigned course'));
                html = html.replace(new RegExp('{{.lower_content}}', "gi"), (metadata !='' && metadata.enable ? metadata.lower_content : 'Regards,'));
                html = html.replace(new RegExp('{{.url}}', "gi"), result? mainUrl+result.url+'rmId='+encrypt(result.courseId)+'&t=1&sKey='+result.sessionKey : mainUrl+'/my-courses' );
                html = html.replace(new RegExp('{{.unsubscribe}}', "gi"), '');
                // html = html.replace(new RegExp('{{.unsubscribe}}', "gi"), (data && (data.companyId == 57  || data.companyId == 260) ? '' : '<p style="text-align:center;line-height:26px">Not interested in receiving this type of mail?<br> Update subscription preferences: <a href="'+mainUrl+'/unsubscribe?unsubscribe_code='+result.code+'&mId=RXertMZt">Unsubscribe</a></p>') );
                html = html.replace(new RegExp('{{.companyName}}', "gi"), (data.name && data.name != '' ? data.name : 'Krademy LMS') );
                return html;
            }
        } catch (err) {
            console.log('conversion fail', err)
            return template.html;   
        }
    },

    generateCourseCompletionHtml: (result, template, data, metadata) => {
        try {
            var mainUrl = (data.MetaData && data.MetaData.length > 0 ? data.MetaData[0].value : config.app.url);
            if(metadata !='' && metadata.enable && metadata.type == 'image' && !(_.isEmpty(metadata.filename)) ){
                var html = '<!DOCTYPE html> <html> <head> <title></title> </head> <body> <p>&nbsp;</p> <div style="width:500px; margin-top:0; margin-bottom:0; margin-left:auto; margin-right:auto; box-shadow: 0px 0px 2px grey;"><a href="'+mainUrl+'/course-auth?rmId='+encrypt(result.courseId)+'&t=1&sKey='+result.sessionKey+'"><img src="cid:'+metadata.filename+'" style="width: 100%; height: auto;border: 1px solid #efefef;" /></a></div> </body> </html>';
                return html;
            }else{
                var html = template.html;
                var extracontent = '';
                html = html.replace(new RegExp('{{.logo}}', "gi"), (data.logo && data.logo != '' ? 'cid:'+data.logo : 'cid:lms-logo.png'));
                html = html.replace(new RegExp('{{.firstName}}', "gi"), result?capitalizeFirstLetter(result.firstName):'');
                html = html.replace(new RegExp('{{.lastName}}', "gi"), result?(result.lastName ? ' '+capitalizeFirstLetter(result.lastName) : ''):'');
                html = html.replace(new RegExp('{{.courseName}}', "gi"), result?result.courseName:'');
                html = html.replace(new RegExp('{{.url}}', "gi"), result ? mainUrl+result.url+'rmId='+encrypt(result.courseId)+'&t=1&sKey='+result.sessionKey : mainUrl+'/my-courses');
                html = html.replace(new RegExp('{{.upper_content}}', "gi"), (metadata !='' && metadata.enable ? metadata.upper_content : 'Congratulations, you have unlocked your certificate of course completion.'));
                html = html.replace(new RegExp('{{.extralink}}', "gi"), (metadata != '' && metadata.enable && metadata.middle_content ? '<div style="font-size: 16px;line-height: 30px;font-family:Arial;color:#4a4848;margin-bottom: 13px;margin-top: 8px;padding: 0px 20px;text-align:left;">'+metadata.middle_content+'</div>' : extracontent));
                html = html.replace(new RegExp('{{.lower_content}}', "gi"), (metadata !='' && metadata.enable ? metadata.lower_content : 'Regards,'));
                html = html.replace(new RegExp('{{.unsubscribe}}', "gi"), '');
                // html = html.replace(new RegExp('{{.unsubscribe}}', "gi"), (data && (data.companyId == 57 || data.companyId == 260) ? '' : '<p style="text-align:center;line-height:26px">Not interested in receiving this type of mail?<br> Update subscription preferences: <a href="'+mainUrl+'/unsubscribe?unsubscribe_code='+result.code+'&mId=RXertMZt">Unsubscribe</a></p>') );
                html = html.replace(new RegExp('{{.companyName}}', "gi"), (data.name && data.name != '' ? data.name : 'Krademy LMS') );
                return html;
            }
        } catch (err) {
            console.log('conversion fail', err)
            return template.html;   
        }
    },

    wonderCementTemplate: (result) => {
        try {
            var html = '';
            for(var i = 0; i < result.courseOrQuiz.length; i++)
                html = '<!DOCTYPE html> <html> <head> <title></title> </head> <body> <p>&nbsp;</p> <div style="width:500px; margin-top:0; margin-bottom:0; margin-left:auto; margin-right:auto; box-shadow: 0px 0px 2px grey;"><a href="'+config.app.url+'/course-auth?rmId='+encrypt(result.courseOrQuiz[i].id)+'&t=1&sKey='+result.sessionKey+'"><img src="cid:Wonder_Cement_Email.jpg" style="width: 100%; height: auto;border: 1px solid #efefef;" /></a></div> <style type="text/css"> </style> <p><img alt="" border="0" height="1" src="' +config.app.url+'/tracker?sId='+result.sessionKey + '" style="height:1px!important;width:1px!important;border-width:0!important;margin-top:0!important;margin-bottom:0!important;margin-right:0!important;margin-left:0!important;padding-top:0!important;padding-bottom:0!important;padding-right:0!important;padding-left:0!important" width="1"></p> </body> </html>';
            return html;
        } catch (err) {
            console.log('conversion fail', err)
            return '';   
        }
    }
}