'use strict';
module.exports = (sequelize, DataTypes) => {
  const CampaignCourse = sequelize.define('CampaignCourse', {
    campaignId: DataTypes.INTEGER,
    courseId: DataTypes.INTEGER
  }, {
    timestamps: true,
    paranoid: true,
  });
  CampaignCourse.associate = function(models) {    
    models.CampaignCourse.belongsTo(models.Campaign, {foreignKey: 'campaignId'});
    models.CampaignCourse.belongsTo(models.Course, {foreignKey: 'courseId'});
    models.CampaignCourse.hasMany(models.Simulation, {foreignKey: 'campaignId'});
    models.CampaignCourse.hasMany(models.SimulationReminder, {foreignKey: 'campaignCourseId'});
  };
  return CampaignCourse;
};