'use strict';
module.exports = (sequelize, DataTypes) => {
  const Company = sequelize.define('Company', {
    alias: DataTypes.STRING,
    name: DataTypes.STRING,
    logo: DataTypes.STRING,
    key: DataTypes.STRING,
    referralId: DataTypes.INTEGER,
    smtpStatus: DataTypes.STRING,
    skipLogin: DataTypes.BOOLEAN
  }, {});
  Company.associate = function(models) {
    models.Company.belongsTo(models.Employee, {foreignKey: 'referralId'});
    models.Company.hasMany(models.MetaData, {foreignKey: 'companyId'});
    models.Company.hasMany(models.Employee, {foreignKey: 'companyId'});
    models.Company.hasMany(models.Policy, { foreignKey: 'companyId' });
    models.Company.hasMany(models.User, { foreignKey: 'companyId' });
    models.Company.hasMany(models.Group, { foreignKey: 'companyId' });
    models.Company.hasMany(models.Quiz, { foreignKey: 'companyId' });
    models.Company.hasMany(models.CourseQuizQuestion, { foreignKey: 'companyId' });
    models.Company.hasMany(models.UserPackage, { foreignKey: 'companyId' });
    models.Company.hasMany(models.Sender, { foreignKey: 'companyId' });
  };
  return Company;
};