 'use strict';
module.exports = (sequelize, DataTypes) => {
  const Course = sequelize.define('Course', {
    name: DataTypes.STRING,
    logo: DataTypes.STRING,
    description: DataTypes.STRING,
    setting: DataTypes.TEXT,
    status: DataTypes.STRING,
    languageId: DataTypes.INTEGER,
    companyId: DataTypes.INTEGER,
    totalDuration: DataTypes.INTEGER,
    totalSection: DataTypes.INTEGER,
    totalLecture: DataTypes.INTEGER,
    courseType: DataTypes.STRING,
    instructorDetail: DataTypes.STRING  
  }, {
    timestamps: true, 
    paranoid: true,
  });
  Course.associate = function(models) {
    // associations can be defined here
    models.Course.hasMany( models.CourseSection ,{ forigenKey: 'courseId' });
    models.Course.hasMany( models.MemberCourse ,{ forigenKey: 'courseId' });
    models.Course.belongsTo(models.Language, { foreignKey: 'languageId'});
    models.Course.hasMany(models.CampaignCourse, { foreignKey: 'courseId'});
    models.Course.hasMany(models.CourseSkill, { foreignKey: 'courseId'});
    models.Course.hasMany(models.CourseUserQuizAnswer, { foreignKey: 'courseId'});
  };
  return Course;
};