'use strict';
module.exports = (sequelize, DataTypes) => {
  const CourseQuizQuestion = sequelize.define('CourseQuizQuestion', {
    companyId:DataTypes.INTEGER,
    title: DataTypes.TEXT,
    marks: DataTypes.INTEGER,
    thumbnail: DataTypes.STRING
  }, {
    timestamps: true,
    paranoid: true
  });
  CourseQuizQuestion.associate = function(models) {
    models.CourseQuizQuestion.belongsTo(models.Company , { foreignKey: 'companyId'});
    models.CourseQuizQuestion.hasMany(models.CourseLectureQuestion , { foreignKey: 'courseQuizQuestionId'});
    models.CourseQuizQuestion.hasMany(models.CourseQuizQuestionOption , { foreignKey: 'courseQuizQuestionId'});
    models.CourseQuizQuestion.hasMany(models.CourseUserQuizAnswer , { foreignKey: 'courseQuizQuestionId'});
  };
  return CourseQuizQuestion;
};