'use strict';
module.exports = (sequelize, DataTypes) => {
  const CourseSectionLecture = sequelize.define('CourseSectionLecture', {
    courseSectionId: DataTypes.INTEGER,
    name: DataTypes.TEXT,
    totalDuration: DataTypes.INTEGER,
    storageLocation: DataTypes.STRING,
    contentId: DataTypes.INTEGER,
    remoteKey: DataTypes.STRING,
    type: DataTypes.STRING,
    questionCount: DataTypes.INTEGER,
    description: DataTypes.TEXT
  }, {
    timestamps: true,
    paranoid: true,
  });
  CourseSectionLecture.associate = function(models) {
    models.CourseSectionLecture.belongsTo(models.CourseSection , { foreignKey: 'courseSectionId'});
    models.CourseSectionLecture.belongsTo(models.Content , { foreignKey: 'contentId'});
    models.CourseSectionLecture.hasMany(models.SessionCourseLectureTracking , { foreignKey: 'courseSectionLectureId'});
    models.CourseSectionLecture.hasMany(models.CourseLectureQuestion , { foreignKey: 'courseSectionLectureId'});
    models.CourseSectionLecture.hasMany(models.CourseUserQuizAnswer , { foreignKey: 'courseSectionLectureId'});
    models.CourseSectionLecture.hasMany(models.CourseUserQuizDetail , { foreignKey: 'courseSectionLectureId'});
  };
  return CourseSectionLecture;
};