import bcrypt from 'bcrypt-nodejs';
export default (sequelize, DataTypes) => {
  const employee = sequelize.define('Employee', {
    firstName: DataTypes.STRING,
    lastName: DataTypes.STRING,
    email: DataTypes.STRING,
    password: DataTypes.STRING,
    phone: DataTypes.STRING,
    status: DataTypes.INTEGER,
    valid: DataTypes.INTEGER,
    attempt: DataTypes.INTEGER,
    verf_key: DataTypes.STRING,
    isNewUser: DataTypes.INTEGER,
    companyId: DataTypes.INTEGER,
    resetPassword: DataTypes.INTEGER,
    deletedAt:DataTypes.DATE,
    otp: DataTypes.STRING,
    otpExpiry: DataTypes.DATE,
  }, {
    timestamps: true,
      paranoid: true,
  });
  employee.associate = function(models) {
    models.Employee.belongsTo(models.Company, {foreignKey: 'companyId'});
    models.Employee.hasMany(models.UserPolicy, { foreignKey: 'userId' });

  };
  employee.prototype.comparePassword = function (password) {
    var dbPass = this.getDataValue('password');
    return bcrypt.compareSync(password, dbPass);
}
  return employee;
};