'use strict';
module.exports = (sequelize, DataTypes) => {
  const MemberCourse = sequelize.define('MemberCourse', {
    sessionId: DataTypes.INTEGER,
    courseId: DataTypes.INTEGER,
    quizId: DataTypes.INTEGER,
    memberId: DataTypes.INTEGER,
    percent: DataTypes.INTEGER,
    completedAt : DataTypes.STRING,
    certificateNo: DataTypes.STRING,
    issuedDate: DataTypes.STRING,
    isDownloaded: DataTypes.INTEGER,
    fileName: DataTypes.STRING,
    quizId: DataTypes.INTEGER,
    quizTimer: DataTypes.STRING,
  }, {
    timestamps: true,
    paranoid: true
  });
  MemberCourse.associate = function(models) {
    // associations can be defined here
    models.MemberCourse.belongsTo(models.Quiz, { foreignKey: 'quizId'});
    models.MemberCourse.belongsTo(models.Course, { foreignKey: 'courseId'});
    models.MemberCourse.belongsTo(models.Quiz, { foreignKey: 'quizId'});
    models.MemberCourse.belongsTo(models.Session, { foreignKey: 'sessionId'});
    models.MemberCourse.belongsTo(models.Member, { foreignKey: 'memberId'});

  };
  return MemberCourse;
};