import bcrypt from 'bcrypt-nodejs';

module.exports = (sequelize, DataTypes) => {
  const MetaAuth = sequelize.define('MetaAuth', {
    email: DataTypes.STRING,
    password: DataTypes.STRING,
    password2: DataTypes.STRING,
    password3: DataTypes.STRING,
    valid: DataTypes.INTEGER,
    isNewUser: DataTypes.INTEGER,
    attempt: DataTypes.STRING,
    resetAttempt: DataTypes.DATE,
    otp: DataTypes.STRING,
    otpExpiry: DataTypes.STRING,
    verf_key: DataTypes.STRING,
    userId: DataTypes.INTEGER,
    memberId: DataTypes.INTEGER,
    status: DataTypes.INTEGER,
    loggedOutAt: DataTypes.DATE
  }, {});
  MetaAuth.associate = function(models) {
    // associations can be defined here
    models.MetaAuth.belongsTo(models.User, {foreignKey: 'userId'});
    models.MetaAuth.belongsTo(models.Member, {foreignKey: 'memberId'});
  };
  MetaAuth.prototype.comparePassword = function (password) {
    var dbPass = this.getDataValue('password');
    return bcrypt.compareSync(password, dbPass);
  }
  return MetaAuth;
};