'use strict';
module.exports = (sequelize, DataTypes) => {
  const QuizQuestion = sequelize.define('QuizQuestion', {
    quizId: DataTypes.INTEGER,
    title: DataTypes.TEXT,
    marks: DataTypes.INTEGER,
    thumbnail: DataTypes.STRING
  }, {
    timestamps: true,
    paranoid: true,
  });
  QuizQuestion.associate = function(models) {
  models.QuizQuestion.belongsTo(models.Quiz, { foreignKey: 'quizId'});
  models.QuizQuestion.hasMany(models.QuizQuestionOption, { foreignKey: 'quizQuestionId'});
  models.QuizQuestion.hasMany(models.QuizSecctionTracking, { foreignKey: 'quizQuestionId'});
  };
  return QuizQuestion;
};