'use strict';
module.exports = (sequelize, DataTypes) => {
  const Session = sequelize.define('Session', {
    memberId: DataTypes.INTEGER,
    simulationId: DataTypes.INTEGER,
    groupId: DataTypes.INTEGER,
    companyId: DataTypes.INTEGER,
    firstName: DataTypes.STRING,
    lastName: DataTypes.STRING,
    email: DataTypes.STRING,
    phone: DataTypes.STRING,
    sessionKey: DataTypes.STRING,
    status: DataTypes.STRING,
    isAssigned: DataTypes.INTEGER
  }, {
    timestamps: true,
    paranoid: true,
  });
  Session.associate = function(models) {
    models.Session.belongsTo(models.Member, {foreignKey: 'memberId'});
    models.Session.hasMany(models.MemberCourse, {foreignKey: 'sessionId'});
    models.Session.hasMany(models.SessionEvent, {foreignKey: 'sessionId'});
    models.Session.belongsTo(models.Simulation, {foreignKey: 'simulationId'});
    models.Session.belongsTo(models.Group, {foreignKey: 'groupId'});
    models.Session.hasMany(models.SessionCourseLectureTracking, {foreignKey: 'sessionId'});
    models.Session.hasMany(models.QuizSecctionTracking, {foreignKey: 'sessionId'});
    models.Session.hasMany(models.QuizUserDetail, {foreignKey: 'sessionId'});
    models.Session.hasMany(models.CourseUserQuizAnswer , { foreignKey: 'sessionId'});
    models.Session.hasMany(models.CourseUserQuizDetail , { foreignKey: 'sessionId'});
  };
  return Session;
};