'use strict';
module.exports = (sequelize, DataTypes) => {
  const Simulation = sequelize.define('Simulation', {
    campaignId: DataTypes.INTEGER,
    type: DataTypes.STRING,
    settings: DataTypes.TEXT,
    scheduledId: DataTypes.INTEGER,
    scheduledAt: DataTypes.DATE,
    launchedAt:  DataTypes.DATE,
    executedAt:  DataTypes.DATE
  }, { 
    timestamps: true,
    paranoid: true,
   });
  Simulation.associate = function(models) {
    models.Simulation.belongsTo(models.Campaign, {foreignKey: 'campaignId'});
    models.Simulation.hasMany(models.Session, {foreignKey: 'simulationId'});
    models.Simulation.belongsTo(models.CampaignCourse, {foreignKey: 'campaignId'});
    models.Simulation.hasMany(models.CampaignQuiz, {foreignKey: 'campaignId'});
    models.Simulation.hasMany(models.SimulationReminder, {foreignKey: 'simulationId'});
  };
  return Simulation;
};