import bcrypt from 'bcrypt-nodejs';

export default (sequelize, DataTypes) => {
    const User = sequelize.define('User', {
        firstName: DataTypes.STRING,
        lastName: DataTypes.STRING,
        email: DataTypes.STRING,
        // password: DataTypes.STRING,
        // status: DataTypes.ENUM('active', 'inactive'),
        // valid: DataTypes.INTEGER,
        // attempt: DataTypes.INTEGER,
        // verf_key: DataTypes.STRING,
        // phone: DataTypes.STRING,
        // loggedOutAt: DataTypes.DATE,
        // isNewUser: DataTypes.INTEGER,
        companyId: DataTypes.INTEGER,
        trial: DataTypes.INTEGER,
        // otp: DataTypes.STRING,
        // otpExpiry: DataTypes.DATE,

    }, {
            timestamps: true,
            paranoid: true,
        });
    User.associate = function (models) {
        models.User.belongsTo(models.Company, {foreignKey: 'companyId'});
        models.User.hasMany(models.UserPolicy, {foreignKey: 'userId'});
        models.User.hasMany(models.MetaAuth, {foreignKey: 'userId'});
        models.User.hasMany(models.Company, {foreignKey: 'referralId'});
        models.User.hasMany(models.AppsumoCode, {foreignKey: 'userId'});
        models.User.hasMany(models.RecentActivity, {foreignKey: 'userId'});
    };

    // User.prototype.comparePassword = function (password) {
    //     var dbPass = this.getDataValue('password');
    //     return bcrypt.compareSync(password, dbPass);
    // }
    return User;
};