var clearAllErrors = function(){
    $('#error_firstName').text('');
    $('#error_lastName').text('');
    $('#error_email').text('');
    $('#error_password').html('');
    $('#error_code').text('');
    $('#error_all').text('');
}

var validateSumoLings = function(){
    clearAllErrors();
    var data = new Object();
    data.firstName = $('#firstName').val();
    var error = 0;
    if(data.firstName.length == 0){
        $('#error_firstName').text('Please enter first name.');
        error = 1;
    }
    data.lastName = $('#lastName').val();
    if(data.lastName.length == 0){
        $('#error_lastName').text('Please enter last name.');
        error = 1;
    }
    data.email = $('#email').val();
    if(data.email.length == 0){
        $('#error_email').text('Please enter email.');
        error = 1;
    }else if(!validateEmail(data.email)){
        $('#error_email').text('Please enter valid email.');
        error = 1;
    }
    data.password = $('#password').val();
    if(data.password.length == 0){
        $('#error_password').html('Please enter password.');
        error = 1;
    }else if(data.password.length < 8 || data.password.length > 15){
        $('#error_password').html('<li style="font-size: 13px;">Password has to be between 8 to 15 characters</li><li style="font-size: 13px;">Password should contain at least one numeric digit</li><li style="font-size: 13px;">Contain at least one uppercase letter</li><li style="font-size: 13px;">Contain at least one lowercase letter</li><li style="font-size: 13px;">Use at least one special character from $, @, !, %, *, #, ?, or &</li>');
        error = 1;
    }else{
        var regex = new Array();
        regex.push("[A-Z]"); //Uppercase Alphabet.
        regex.push("[a-z]"); //Lowercase Alphabet.
        regex.push("[0-9]"); //Digit.
        regex.push("[$@!%*#?&]"); //Special Character.
        var passed = 4;
        for (var i = 0; i < regex.length; i++) {
            if(i != 4 && new RegExp(regex[i]).test(data.password))
                passed--;
        }
        if(passed > 0){
            $('#error_password').html('<li style="font-size: 13px;">Password has to be between 8 to 15 characters</li><li style="font-size: 13px;">Password should contain at least one numeric digit</li><li style="font-size: 13px;">Contain at least one uppercase letter</li><li style="font-size: 13px;">Contain at least one lowercase letter</li><li style="font-size: 13px;">Use at least one special character from $, @, !, %, *, #, ?, or &</li>');
            error = 1;
        }
    }
    data.code = $('#code').val();
    if(data.code.length == 0){
        $('#error_code').text('Please enter code.');
        error = 1;
    }
    
    if(error == 0)  return data;
    else return false
}

var load = function(data){
    api.auth.login(data, function (success) {
        if(success && success.success)
            window.location = '/';
    }, function (err) {
       console.log(JSON.stringify(err.errors));
    })
}

var getStarted = function(){
    var data = validateSumoLings();
    if(data){
        var newData = new Object();
        newData.email = data.email;
        newData.password = data.password;
        api.appsumo.post(data,function(success){
            if(success && success.status)
                load(newData);
        },function(error)  {
            if(error && error.errors && error.errors[0]){
                var str = error.errors[0];
                if(str.indexOf('Email') != -1) 
                    $('#error_email').text(str);
                else if(str.indexOf('Code') != -1)
                    $('#error_code').text(str);
                else $('#error_all').text(str);
            }else {
                if(error.details && error.details[0] && error.details[0].context.key == 'password'){
                    $('#error_password').html(error.details[0].message);
                }else $('#error_all').text('Something went wrong!');
            }
        });
    }
}

$(document).ready(function(){
    $('#error_code').text('');
    if(err != "")
        $('#error_code').text(err);
    var dataAllInputs  = document.getElementsByTagName("input");
    for (var i = 0; i < dataAllInputs.length; i++) 
        dataAllInputs[i].setAttribute('autocomplete', 'off');
})