var sessionIds = [];

function getCourseDepartment(MemberCourses) {
    let deparmentCount = 0,studentCount=0;
    MemberCourses.forEach(function(member)  {
        if (member.Session)
            studentCount++;
        if (member.Session.Group) {
            if ($.inArray(member.Session.Group.id, sessionIds) == -1) {
                sessionIds.push(member.Session.Group.id)
                deparmentCount++;
            }
        }
    })
    let data = JSON.stringify({ 'department': deparmentCount, 'activeStudent': studentCount });
    return data;
}

function appendCourses(course, i) {
    duration = secondsToTime(course.totalDuration);
    sessionIds.splice(0, sessionIds.length);
    var courseData = JSON.parse(getCourseDepartment(course.MemberCourses));
    $('#courseList tbody').append('<tr> <th scope="row">' + i + '</th> <td>' + course.name + '</td> <td>' + duration + '</td> <td>' + courseData.department + '</td> <td>' + courseData.activeStudent + '</td> <td><a href="/analytic/' + course.id + '">See Details</a><i class="feather icon-chevron-right"></i></td> </tr>');
}


var searchQuery = function(){
    setPage(1);
    setCourseData();
}

var clearCourse = function () {
    $('#courseList tbody').html('');
    $('#paginate').hide();
}

var validate = function () {
    clearErrors();
    var data = new Object();
    data.search = $('#searchBar').val();
    if (data.search.length < 3) {
        data.search = undefined;
    }
    data.page = getPageNo();
    data.limit = getLimit();
    hasError() && showErrors();
    return data;
}

var reloadList = function () {
    setCourseData();
}

function setCourseData() {
    var data  = validate();
    $('#loader-wrap').show();
    !hasError() && api.analytic.get(data, function (success) {
        // console.log(success)
        $('#loader-wrap').hide();
        if (success && success.course) {
            clearCourse();
            var i = 1;
            success.course.forEach(function(acourse) {
                appendCourses(acourse, i);
                i++;
            });
            if (success.count > 0) {
                $('#paginate').show();
                addPagination(success.pages, success.count);
            }else{
                $('#courseList tbody').html(' No Course Found.');
            }
        }
        
    }, function(err) {}, false);
}

function loadCoursesGraph() {
    api.analytic.courseGraph(undefined, function (success) {
        var months = []; var data = [];
        var tempDate = new Date();
        tempDate.setMonth(tempDate.getMonth() - 6);
        for (var i = 0; i < 7; i++) {
            var monthString = moment(tempDate).format("MMM");
            months.push(monthString);
            if (success.graph[monthString]) data.push(Math.round(success.graph[monthString] / 60));
            else data.push(0);
            tempDate.setMonth(tempDate.getMonth() + 1);
        }
        renderChart(data, months);
    });
}

function setCourseList() {
    api.analytic.list(undefined, function (success) {
        if (success && success.course) {
            success.course.forEach(function(coursename) {
                $('#published-course').append('<a class="dropdown-item" href="/analytic/' + coursename.id + '">' + coursename.name + '</a>');
            })
        }
    });
}

function renderChart(data, months) {
    var options = {
        chart: {
            height: 362,
            type: 'bar',
            toolbar: {
                show: false
            },
        },
        plotOptions: {
            bar: {
                horizontal: false,
                columnWidth: '25%',
                endingShape: 'rounded'
            },
        },
        dataLabels: {
            enabled: false
        },
        stroke: {
            show: true,
            width: 2,
            colors: ['transparent']
        },
        colors: ['#0080ff', '#d4d8de'],
        series: [{
            name: 'Course Minutes',
            data: data
        }],
        legend: {
            show: false,
        },
        xaxis: {
            categories: months,
            axisBorder: {
                show: true,
                color: 'rgba(0,0,0,0.05)'
            },
            axisTicks: {
                show: true,
                color: 'rgba(0,0,0,0.05)'
            }
        }
    }
    var chart = new ApexCharts(
        document.querySelector("#apex-bar-chart"),
        options
    );
    chart.render();

}

function ShowTotalCount(){
    api.analytic.showtotalcount(undefined, function (success) {
    //    console.log(success)
       if(success && success.success == true){
            $('#minute').text((success.mintaught ? success.mintaught : 0));
            $('#student').text(success.activeLearner ? success.activeLearner : 0);
            $('#department').text(success.departmentcount ? success.departmentcount : 0);
       }
    });
}

$(document).ready(function () {
    setCourseList();
    ShowTotalCount();
    setCourseData();
    loadCoursesGraph();
});