var language = null;
var skill = null;
var fromDate = null, toDate = null;
var lastApi = null;
var searchQuery = null;
var sortBy = 'recent';
var count = 0;
var meetingDateCrossed  = false;

var searchQuery = function() {
    setPage(1);
    load(false);
}
var switchToGrid = function() {
    $('#List').css({ "display": "none" });
    $('#Grid').css({ "display": "inline" });
    $('#gridView').css({ "display": "block" });
    $('#tableView').css({ "display": "none" });
}

var switchToList = function() {
    $('#Grid').css({ "display": "none" });
    $('#List').css({ "display": "inline" });
    $('#gridView').css({ "display": "none" });
    $('#tableView').css({ "display": "block" });
}
var dateFilterInit = function () {
    var currentDate = new Date();
    var prevDate = new Date();
    prevDate.setMonth(prevDate.getMonth() - 1);
    fromDate = prevDate.toString('yyyy/MM/dd');
    toDate = currentDate.toString('yyyy/MM/dd');
    $('input[name="date-range"]').daterangepicker({
        opens: 'left',
        startDate: prevDate,
        endDate: currentDate,
        maxDate: new Date(),
    }, function (start, end, label) {
        fromDate = start.format('YYYY/MM/DD');
        toDate = end.format('YYYY/MM/DD');
        load();
    });
}

var validate = function () {
    clearErrors();
    var data = new Object();
    data.search = $('#searchBar').val();
    if (data.search.length < 3) {
        data.search = undefined;
    }
    if (sortBy) data.sort = sortBy;
    data.page = getPageNo();
    if (fromDate != null && toDate != null) {
        data.fromDate = fromDate;
        data.toDate = toDate;
    }
    if (language)
        data.language = language;
    if (skill)
        data.skill = skill;
    data.limit = getLimit();
    hasError() && showErrors();
    return data;
}

var sort = function (type) {
    sortBy = type;
    load();
}

var languageFilter = function (type) {
    if (type == 'all')
        language = null;
    else
        language = type;
    load();
  }

function resetCourseFilter(){
    dateFilterInit();
    language = null;
    sortBy = 'recent';
    skill = null;
    fromDate = null, 
    toDate = null;
    load();
}

function viewCourseAnalytics(status, id) {
    if(status == 'Published'){
        window.location = '/analytic/'+id;
    }else  swal({ title: "Warning!",  type: "warning", text: "Your Course is not Published!" });
}

function setTypeFunction(type){
        window.location.href = "/course/create?type="+type;
}

function joimMeetingModeartor(data){
    var URL = "https://meet.krademylms.com/bigbluebutton/api/join?"+data;
    window.open(URL, '_blank')
}

var addCourse = function (detail, name) {
    if(detail.courseType == 'streaming'){
        var startTimerCheck = false;
        var d = new Date();
        var currentDate = d.getDate() + "/" + (d.getMonth()+1) + "/" + d.getFullYear();
        var formatedDate = new Date(detail.createdAt).toString().substr(0, 25);
        if (detail.name && detail.Language.name) {
            var skills = '', color = '';
            if(detail.CourseSkills && detail.CourseSkills.length > 0){
                var data = [];
                for(var i = 0; i < detail.CourseSkills.length; i++){
                    if(detail.CourseSkills[i] && detail.CourseSkills[i].Skill  && detail.CourseSkills[i].Skill.name )
                    data.push(detail.CourseSkills[i].Skill.name);
                }
                var skills = data.join(', ');
            }
            if(detail.courseType == 'instructor' && detail.instructorDetail){
                var meet_meta = JSON.parse(detail.instructorDetail);
                var days = (parseInt(meet_meta.date) -parseInt(currentDate)) / (1000 * 60 * 60 * 24);
                var check = (parseInt(days) <= 1 ? true : false);
                if(check){
                    timer(detail.id,meet_meta.date,meet_meta.time)
                    var current_AMPM_time = getCurrentTime();
                    if(parseInt(days) == 1){
                        if(current_AMPM_time > meet_meta.time)
                            startTimerCheck = true;
                    }else if(parseInt(days) <= 0){
                        if(current_AMPM_time <= meet_meta.time)
                            startTimerCheck = true;
                        if(meet_meta.expired != 1){
                            startTimerCheck = true;
                        }
                    }
                }
                var data = "fullName="+name+"&meetingID="+meet_meta.meetingId+"&password=mp&redirect=true";
                var meta = "join"+data+'N5o0kZeF412DMo9Uh6gvZikc7gjglKgeGqXBig3wD4';
                var checksum = SHA1(meta);
                data = data+"&checksum="+checksum;
            }
            if(detail.status == 'Active') color = '#41be41';
            else if(detail.status == 'Published') color = '#f28a3c';
            else color = '#c1c1d7';
            var listView = '<tr> <th scope="row"><a href="/course/create/' + detail.id + '?type=course" >' + detail.name + '</a></th><td>'+skills+'</td> <td>' +  (detail && detail.totalLecture ? detail.totalLecture : 0) + ' Lectures</td>  <td>' + detail.Language.name + '</td> <td>'+detail.status+'</td>  <td>' + formatedDate + '</td> <td>'+(detail.status == 'Published' && detail.courseType == 'instructor' ? '<div class="start_met startMeet_'+detail.id+'" '+(detail.status == 'Published' ? (startTimerCheck == false? 'style="display:none;"' : '' ) : 'style="display:none;"')+'><button type="button" class="btn btn-primary" disabled id="cls_list_'+detail.id+'" onclick="joimMeetingModeartor(\''+data+'\');">Start Meeting</button> <p class="demo_list_'+detail.id+'" id="demo"></p></div> <p id="listmeet_'+detail.id+'" style="display:none;color:red;"><b>Meeting Expired</b></p>  ' : (detail.courseType == 'instructor' ? ' <div class="add_date_time addListDateTime_'+detail.id+'" '+(detail.status == 'Published' ? (startTimerCheck ? 'style="display:none;"' : '' ): '')+'> <p><span> <i class="feather icon-calendar"></i> Date - </span> '+(detail.courseType == 'instructor' ? meet_meta.date : '-')+' </p> <p><span> <i class="feather icon-clock"></i> Time - </span> '+(detail.courseType == 'instructor' ? meet_meta.time : '-')+' </p> </div>': '<a data-toggle="tooltip" data-placement="top" title="" data-original-title="Preview" class="btn btn-round btn-warning-rgba " href="/course/preview/' + detail.id + '" target="_blank"> <i class="feather icon-eye"></i </a><a data-toggle="tooltip" data-placement="top" title="" data-original-title="Analytics" class="btn btn-round btn-warning-rgba" href="javascript:void(0);" onclick="viewCourseAnalytics(\''+detail.status+'\', '+detail.id+')"><i class="feather icon-bar-chart-line-"></i></a>'))+'</td> </tr>'
            $('#courseTable').append(listView);
           //<h6 class="skills-text"><i class="feather icon-user"></i> Author - <span>Anjani Pandey</span></h6>
            var gridView = ' <div class=" row grid_course_view"> <div class=" col-sm-2 grid_sty img_show"> <img class="img-fluid" src="/static/course/logo/' + detail.logo + '"> </div> <div class="col-sm-4 grid_sty content-head"> <div class="content"> <h5>' + detail.name + '</h5><p class="date-text">' + formatedDate + '</p> <h6 class="skills-text"><i class="feather icon-box"></i> Skills - <span>'+skills+'</span></h6>  <h6 class="skills-text"><i class="feather icon-flag"></i> Status - <span class="badge badge-pill badge-success" style="background:'+color+'">'+detail.status+'</span></h6> <h6 class="skills-text"><i class="feather icon-eye"></i> Course Type - '+(detail.courseType == 'instructor' ? "Live Instructor Led" : "Streaming")+'</h6>      <a href="/course/create/' + detail.id + '?type=course" class="content-hover"><span>Manage Course</span></a> </div> </div> <div class="col-sm-2 grid_sty content-head text-center"> <div class="content w-100"> <h5 class="block-head">Lectures</h5><p>' + (detail && detail.totalLecture ? detail.totalLecture : 0) + '</p>  <a href="/course/create/' + detail.id + '?type=curriculum" class="content-hover"><span>Manage Lectures</span></a> </div> </div>  <div class="col-sm-2 grid_sty content-head text-center"> <div class="content w-100"> <h5 class="block-head">Language</h5><p>'+detail.Language.name+'</p> </div> </div><div class="col-sm-2 grid_sty content-head text-center"> <div class="content w-100">'+(detail.courseType == 'instructor' ? '<div class="instr_led"> <div class="add_date_time addDateTime_'+detail.id+'" '+(detail.status == 'Published' ? (startTimerCheck ? 'style="display:none;"' : '' ): '')+'> <h6>Meeting Details</h6><p><span> <i class="feather icon-calendar"></i> Date - </span> '+(detail.courseType == 'instructor' ? meet_meta.date : '-')+' </p> <p><span> <i class="feather icon-clock"></i> Time - </span> '+(detail.courseType == 'instructor' ? meet_meta.time : '-')+' </p> </div><div class="start_met startMeet_'+detail.id+'" '+(detail.status == 'Published' ? (startTimerCheck == false? 'style="display:none;"' : '' ) : 'style="display:none;"')+'><button type="button" class="btn btn-primary" disabled id="cls_'+detail.id+'" onclick="joimMeetingModeartor(\''+data+'\');">Start Meeting</button> <p class="demo_'+detail.id+'" id="demo"></p></div> <p id="meet_'+detail.id+'" style="display:none;color:red;"><b>Meeting Expired</b></p> ' : (detail.courseType == 'instructor' ? 'NA': '<a data-toggle="tooltip" data-placement="top" title="" data-original-title="Preview" class="btn btn-round btn-warning-rgba " href="/course/preview/' + detail.id + '" target="_blank"> <i class="feather icon-eye"></i </a><a data-toggle="tooltip" data-placement="top" title="" data-original-title="Analytics" class="btn btn-round btn-warning-rgba" href="javascript:void(0);" onclick="viewCourseAnalytics(\''+detail.status+'\', '+detail.id+')"><i class="feather icon-bar-chart-line-"></i></a>'))+'</div> </div>  </div>';
             
            $('#gridView').append(gridView);
    
            $('[data-toggle="tooltip"]').tooltip({
                trigger : 'hover'
            }) 
    
            if(detail.courseType == 'instructor' && meet_meta.expired == 1){
                $(".startMeet_"+detail.id).css("display","none");
                $(".addDateTime_"+detail.id).css("display","none");
                $("#meet_"+detail.id+"").css("display","block");
                $("#listmeet_"+detail.id+"").css("display","block");
            }
        }
    }
}

var clearCourse = function () {
    $('#gridView').html("");
    $('#courseTable').html('');
    $('#paginate').hide();
}

var load = function(noloader) {
    var data = validate();
    !hasError();
    if (lastApi) {
        lastApi.abort();
        lastApi = null;
    }
    lastApi = api.course.list(data, function(success) {
        clearCourse();
        if (success.count) {
            count = 0; select = true;
            success.course.forEach(function(course) {
                addCourse(course, success.userName);
            });
            lastApi = null;
            if (success.count > 0){
                $('#paginate').show();
                addPagination(success.pages, success.count);
            }
        } else {
            $('#gridView').html('<tr><td colspan="2">No Course Found.</td></tr>');
            $('#courseTable').html('No Course Found.');
        }
    }, function(error) { }, noloader)
}

var reloadList = function () {
    load();
}

var loadLanguages = function() {
    api.course.language(undefined, function(success) {
        $('.inputLang').append('<a class="dropdown-item" onclick="languageFilter(`' + 'all' + '`)">' + 'All' + '</a>')
        for (var i = 0; i < success.languages.length; i++) {
            $('.inputLang').append('<a class="dropdown-item" onclick="languageFilter(`' + success.languages[i].name + '`)">' + success.languages[i].name + '</a>')
        }
    })
}

function skillFilter(id) {
    if (id == 'all')
        skill = null;
    else
        skill = id;
    load();
}

function loadSkills() {
    var type = "DESC";
    api.skill.all({ type: type }, function (success) {
        $('#skills_append').html('<a class="dropdown-item" href="#" onclick="skillFilter(\'all\')">All</a>');
        success.skills.forEach(function(skill) {
            $('#skills_append').append('<a class="dropdown-item" href="#" onclick="skillFilter(' + skill.id + ')">' + skill.name + '</a>');
        });
    });
}

const monthNames = ["January", "February", "March", "April", "May", "June",
  "July", "August", "September", "October", "November", "December"
];


function timer(id,date,time){
    var md = date.substr(0, 2);
    var d = new Date();
    var year = d.getFullYear();
    var countDownDate = new Date(""+monthNames[d.getMonth()]+" "+md+","+year+' '+time).getTime();
    var x = setInterval(function() {
    var now = new Date().getTime();
    var distance = countDownDate - now;
    
    // var days = Math.floor(distance / (1000 * 60 * 60 * 24));
    var hours = Math.floor((distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
    var minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
    var seconds = Math.floor((distance % (1000 * 60)) / 1000);
    
    $('.demo_list_'+id).html('<span>'+hours+'h </span>'
    + '<span>'+minutes+'m </span>' + '<span>'+seconds+'s </span>')

    $('.demo_'+id).html('<span>'+hours+'h </span>'
    + '<span>'+minutes+'m </span>' + '<span>'+seconds+'s </span>')
    if(minutes < 10 && minutes >= 0 && hours == 0){
        $("#cls_"+id).removeAttr("disabled");
        $("#cls_list_"+id).removeAttr("disabled");
    }
    if(hours < 0){
        $(".demo_list_"+id).css("display","none");
        $(".demo_"+id).css("display","none");
        $("#cls_"+id).removeAttr("disabled");
        $("#cls_list_"+id).removeAttr("disabled");
    }
    
//   if (distance < 0) {
//     clearInterval(x);
//     //document.getElementById("demo").innerHTML = "EXPIRED";
//   }
}, 1000);

}

var blurred = false;
window.onblur = function() { blurred = true; };
window.onfocus = function() { blurred && (load())}; 

$(document).ready(function () {
    dateFilterInit();
    load();
    loadLanguages();
    loadSkills();
});