var searchQuery = null;
var searchUserGroup = '';
var searchADUser = '';
var sortBy = 'recent';
var lastApi = null;


var validate = function(){    
    clearErrors();
    var data = new Object();
    data.page = getPageNo();
    data.search = $('#searchBar').val();
    if(data.search.length < 3){
        data.search = undefined;
    }
    data.limit =  getLimit();
    data.sort = sortBy;
    hasError() && showErrors();
    return data;
}

var searchGroupWithAD = function(){
    if(sanitize($('#serchUserGroup').val()).length >= 3){
        searchUserGroup = sanitize($('#serchUserGroup').val())
        loadUserGroupAndUsers(searchUserGroup, false);
    }else if(sanitize($('#serchUserGroup').val()).length == 2) {
        searchUserGroup = ''
        loadUserGroupAndUsers(searchUserGroup, false);
    }
}

var searchUserWithAD = function(){
    if(sanitize($('#serchADUsers').val()).length >= 3){
        searchADUser = sanitize($('#serchADUsers').val())
        loadADUsers(searchADUser, false);
    }else if(sanitize($('#serchADUsers').val()).length == 2) {
        searchADUser = ''
        loadADUsers(searchADUser, false);
    }
}


var clearUserGroups = function(){
    $('#user_group_total').html(''); 
    $('#set_user_groups').html(''); 
}

var setUserGroups = function(data, i){
    $('#set_user_groups').append('<tr> <th scope="row"> <div class="custom-control custom-checkbox col-sm-12"> <input type="checkbox" class="custom-control-input checkBoxClass userGroupsAll" id="selectDepart'+i+'" data-id="'+data.cn+'"> <label class="custom-control-label" for="selectDepart'+i+'"></label> </div> </th> <td>'+data.cn+'</td> </tr>');
}

var loadUserGroupAndUsers = function(search, noloader){
    api.group.fetch({search: (search ? search : undefined), key:(password ? password : undefined)}, function(success) {
        if(success && success.success){
            clearUserGroups();
            if(success.groups.length > 0){
                var userGroupTotal = success.groups.length;
                $('#user_group_total').html(userGroupTotal);
                var i = 1;
                success.groups.forEach(function(grp){
                    setUserGroups(grp, i);
                    ++i;
                })
            }else {
                $('#user_group_total').html(0);
                $('#set_user_groups').html('<tr><th>No User Groups Found.</th></tr>'); 
            }
        }
    }, function(error) {}, noloader)
}

var createADUserGroups = function(){
    clearErrors();
    var data = new Object();
    var valUserGroups = [];
    $('.userGroupsAll:checked').each(function(i){
        valUserGroups.push($(this).attr('data-id'));
    });
    if(valUserGroups.length == 0)
        addError('group', 'Please choose atleast one group.');
    data.userGroups = valUserGroups;
    data.key = (password ? password : undefined);
    hasError() && showErrors();
    !hasError() && api.group.createUserGroups(data, function(success) {
        if(success && success.success){
           
        }
    }, function(error) {})
}

var clearADUsers = function(){
    $('#users_total').html(''); 
    $('#set_users').html(''); 
}

var setUsers = function(data, i){
    $('#set_users').append('<tr> <th scope="row"> <div class="custom-control custom-checkbox col-sm-12"> <input type="checkbox" class="custom-control-input checkBoxUser" id="selectUser'+i+'"> <label class="custom-control-label" for="selectUser'+i+'"></label> </div> </th> <td>'+data.cn+'</td> <td>'+data.userPrincipalName+'</td> </tr>');
}

var loadADUsers = function(search, noloader){
    api.group.users({search: (search ? search : undefined), key:(password ? password : undefined)}, function(success) {
        if(success && success.success){
            clearADUsers();
            if(success.users.length > 0){
                var usersTotal = success.users.length;
                $('#users_total').html(usersTotal);
                var i = 1;
                success.users.forEach(function(user){
                    setUsers(user, i);
                    ++i;
                })
            }else {
                $('#users_total').html(0);
                $('#set_users').html('<tr><th>No User Found.</th></tr>'); 
            }
        }
    }, function(error) {}, noloader)
}

var importWithAD = function(){
    $('#password-ad').val('');
    var data = new Object();
    data.password = password;
    api.group.checkAD(data, function(success) {
        if(success && success.success){ 
            if(success.check){
                $('#myModal2').modal('show');
                loadUserGroupAndUsers(searchUserGroup, true);
            }else $('#passwordLogin').modal('show');
            
        }
    }, function(error) {})
    $('.new_ad_class').removeClass('active');
    $('.tab_pane_depart').removeClass('active');
    $('#pills-profile').addClass('show active');
    $('#pills-profile-tab').addClass('active');
}

var validatePasswordAD = function(){
    clearErrors();
    var data = new Object();
    data.password = sanitize($('#password-ad').val());
    if(data.password.length == 0)
        addError('password-ad', "Please Enter a Password.");
    data.savePassword = $('#savePassword').prop('checked');
    hasError() && showErrors();
    return data;
}

var password = '';

var loginADWithPassword = function(){
    var data = validatePasswordAD();
    !hasError() && api.group.password(data, function(success) {
        if(success && success.success){ 
            if(success.success){
              password = success.key;
              $('#passwordLogin').modal('hide');
              $('#myModal2').modal('show');
              loadUserGroupAndUsers(searchUserGroup, true);
            }
        }
    }, function(error) {})
    $('.new_ad_class').removeClass('active');
    $('.tab_pane_depart').removeClass('active');
    $('#pills-profile').addClass('show active');
    $('#pills-profile-tab').addClass('active');
}

var sort = function(type){
    sortBy = type;
    load();
}

var clearGroups = function(){
    $('#groups tbody').html('');  
    $('#paginate').hide();
}

var redirectDepartment = function(id){
    window.open('/department/'+id, '_blank');
} 

var setTreeJson = function(obj, t, group, dataObj){
    if(group && group.length > 0){
        group.forEach(function(g) {
            var temp = {
                "text" : "<a onclick='redirectDepartment("+g.id+");'>"+g.name+"</a>",
                "state" : { "opened" : true },
                "icon" : (t == 'p' ? "feather icon-folder" : "feather icon-feather")
            }
            if(dataObj && dataObj[g.id]){
                temp["children"] = setTreeJson([], 'c', dataObj[g.id], dataObj);
            }
            obj.push(temp);
        })
    }
    return obj;
}

var loadJsTree = function(data) {
    $('#types-tree').jstree("destroy"); 
    $('#types-tree').jstree({
        'core' : { 
            'themes' : { 'responsive': false },
            'data' : data,
        },
        'plugins' : ['types']
    }); 
}

var addGroup = function(detail){
    var formatedDate = new Date(detail.createdAt).toString('DD MM yyyy h:mm tt').substr(0,25);
    var status = detail.status, statusColor = '';
    var skills = ''
    if(detail.GroupSkills && detail.GroupSkills.length > 0){
        var data = [];
        for(var i = 0; i < detail.GroupSkills.length; i++){
            if(detail.GroupSkills[i] && detail.GroupSkills[i].Skill  && detail.GroupSkills[i].Skill.name )
            data.push(detail.GroupSkills[i].Skill.name);
        }
        var skills = data.join(', ');
    }
    if(status == 'completed')
        statusColor = 'style="color: green;font-size: inherit;"'
    else if(status == 'pending')
        statusColor = 'style="color: orange;font-size: inherit;"';
    else 
        statusColor = 'style="color: red;font-size: inherit;"';
    $('#groups tbody').append('<tr>  <td> <a href="/department/'+ detail.id +'"><h6>' + detail.name + '</h6> <p>Created on ' + formatedDate + '</p></a> </td><td style="width:300px"><h6><span class="skill_list">'+(skills != ''? skills: 'NA')+'</span></h6></td> <td><h6>' + detail.userCount + ' Users </h6></td> <td><h2 '+statusColor+'>'+capitalizeFirstLetter((status == 'failed' ? 'error': status))+' </h2></td> <td><a href="/department/'+ detail.id +'" data-toggle="tooltip" data-placement="top" title="" data-original-title="Edit" class="btn btn-round btn-warning-rgba"><i class="feather icon-edit"></i></a> <a href="#" onclick="deleteGrp(' + detail.id + ')" data-toggle="tooltip" title="" data-placement="top" data-original-title="Delete" class="btn btn-round btn-danger-rgba"><i class="feather icon-trash-2"></i></a></td> </tr>');
    $('[data-toggle="tooltip"]').tooltip({
        trigger : 'hover'
     })
    
}


var deleteGrp = function(groupId){
    swal({ title: 'Are you sure?',  text: "You won't be able to revert this!", type: 'warning', showCancelButton: true, confirmButtonClass: 'btn  btn-success', cancelButtonClass: 'btn btn-danger m-l-10',  confirmButtonText: 'Yes, delete it!'})
    .then(function () {
        api.groupId.delete(groupId, undefined, function(success) {
            if(success && success.success){
                load();
                swal('Deleted!', success.skill, 'success' );
            }
        }, function(error) {})
    })
}

var load = function(noloader = true) {
    var data = validate();
    !hasError(); 
    if(lastApi){
        lastApi.abort();
        lastApi = null;
    }
    lastApi = api.group.get(data, function(success) {
        clearGroups();
        if(success.count){
            success.groups.forEach(function(group) {
                addGroup(group);
            });
            getAllDeptHierarchyData();
            lastApi = null;
        }else {
            $('#groups tbody').html('<tr><td colspan="2">No Department Found.</td></tr>');
        }
        if(success.groups.length > 0){
            addPagination(success.pages, success.count);
            $('#paginate').show();
        }
    }, function(error) {}, noloader)
}


$(".checkAllDepartment").click(function () {
    $(".checkBoxClass").prop('checked', $(this).prop('checked'));
});

 $(".checkBoxClass").change(function(){
    if (!$(this).prop("checked")){
        $(".checkAllDepartment").prop("checked",false);
    }
});

$(".checkAllUser").click(function () {
    $(".checkBoxUser").prop('checked', $(this).prop('checked'));
});

$(".checkBoxUser").change(function(){
    if (!$(this).prop("checked")){
        $(".checkAllUser").prop("checked",false);
    }
});

var searchQuery = function() {
    setPage(1);
    load(false);
}

var paginationData = function(count) {
    setLimit(count);
    setPage(1);
    load();
}

var reloadList = function() {
    load();
}

function getAllDeptHierarchyData(){
    api.group.hierarchyData(undefined,function(success) {
       if(success.success == true){
        var finalArray = []; var dataObj = {}; 
        success.groups.forEach(function(group) {
            if(!dataObj[group.parentId]) dataObj[group.parentId] = [];
                    dataObj[group.parentId].push(group);
        }); 
        finalArray = setTreeJson([], 'p', dataObj[0], dataObj);
        loadJsTree(finalArray);
       }
    });    
}

$(document).ready(function(){
    load();
});