var shouldCount = false;
var videoTime = 0;
var screenTime = 0;
var videoPlayer = null;
var lectureId = 0;
var interval = null;
var fullLecture = {};
var questionOptions = {};
var selectedOptions = {};
var isSeeking = false;
var isSwithching = false;
var isBefore = false;
var percentage = 0;
var completed = {};
var lectureIds = {};
var timer = null;
var pdfCounter = 0;
var questionData = [];
var answerData = {};
var answer = {};
var setLectureCount = 0;

var viewDescription = function(desc) {
    $('.modal-body').html(desc);
}

var loadlLectureList = function(name, lectures) {
    var lecturelist = '';
    if(lectures.length){
        for(var j = 0; j < lectures.length; j++){
            fullLecture[lectures[j].id] = lectures[j];
            var minutes = Math.floor((lectures[j].totalDuration ? lectures[j].totalDuration: 0) / 60);
            var seconds = lectures[j].totalDuration - minutes * 60;
            var duration = minutes+':'+seconds;
            var type = '', percent = 0, lectureId = lectures[j].id;
            if(page.type == 'streaming' &&  lectures[j].type && lectures[j].type.toLowerCase() == 'video') type = 'file-video';
            else if(page.type == 'streaming' &&  lectures[j].type && lectures[j].type.toLowerCase() == 'pdf')  type = 'file-pdf-o';
            else if(page.type == 'streaming' &&  lectures[j].type && lectures[j].type.toLowerCase() == 'doc')  type = 'file-word';
            else if(page.type == 'streaming' &&  lectures[j].type && lectures[j].type.toLowerCase() == 'ppt')  type = 'file-powerpoint';
            else if(page.type == 'streaming' &&  lectures[j].type && lectures[j].type.toLowerCase() == 'xls')  type = 'file-excel-o';
            else type = 'question-circle';
            lectureIds[lectureId] = {
                'type': lectures[j].type,
                'lectureId': lectureId,
                'status': percent>=100?true:false 
            }
            var descData = lectures[j].description;
            if(page.type == 'streaming' && lectures[j].type){
                lecturelist += '<li class="list-group-item '+(j == 0 ? 'active' : '')+'" id="lecture-'+lectures[j].id+'" onclick="checkPermission(\''+lectures[j].id+'\', \''+name+'\', \''+(lectures[j].type == 'video' ? 'video': (lectures[j].type == 'quiz' ? 'quiz' : lectures[j].type) )+'\')"> <h6 class="mb-3"><i class="fa fa-'+type+'"></i> '+lectures[j].name+'</h6><div class="row"> <div class="col-6">'+(lectures[j].type == 'video' ? '<p class="duration">  <i class="fa fa-clock"></i> '+toHHMMSS(lectures[j].totalDuration)+' Hrs &nbsp;</p>' : '')+'</div> <div class="col-6"></div> </div> '+(descData !=null && descData.trim() !="" ? '<button type="button" class="btn btn-outline-primary" data-toggle="modal" data-target="#exampleModal" onclick="viewDescription(\''+descData+'\');" style="float: right;"><i class="feather icon-file mr-2"></i>Description</button><div class="row">  </div> ' : '')+'</li>'
                setLectureCount++;
            }
        }
        if(lecturelist) return lecturelist;
        else return 'No Lecture Found';
    }
    return "No Lecture Found";
}

var checkPermission = function(lecture, name, type) {
    $('.list-group-item').removeClass('active');
    $('#lecture-'+lecture).addClass('active');
    loadContent(lecture, name, type);
}

var hideSideBar=function(){
    $('#course-preview .left-sidebar').fadeOut();
    $('.col-sm-9.right-content').css({"width":"100%","flex": "0 0 100%","max-width": "100%"})
    $('.show-toggle').show();
}

var showSideBar = function(){
    $('#course-preview .left-sidebar').fadeIn();
    $('.col-sm-9.right-content').css({"width":"100%","flex": "0 0 75%","max-width": "75%"})
    $('.show-toggle').hide();
}

var show = function(msg) {
    $('#error').html(msg);
    $('#error').show();
    setTimeout(function(){
        $('#error').hide();
    }, 4000)
}

var currentTime = 0;
var renderVideo = function() {
    videojs(document.getElementById('video1'), {}, function() {
        videoPlayer = this;
        this.play();

        this.on('play', function () {
            shouldCount = true;
        });

        this.on('ended', function () {
            shouldCount = false;
        });

        this.on('pause', function () {
            shouldCount = false;
        });

        this.on("seeking", function (event) {
            videoPlayer.play();
        });

        this.on("seeked", function (event) {
            videoPlayer.play();
        });

        interval = setInterval(function () {
            if (!videoPlayer.paused()) {
                currentTime = videoPlayer.currentTime();
            }
        }, 1000);
    });
}
var loadQuizQuestionOption = function(qId, option,i){
    $('#question-option-'+qId).append('<div class="custom-control custom-radio quuiz_box" style="padding-left: 0px;">'+i+')  <span style="color:black;">'+option.title+'</span>  '+(option.isCorrect ? "<span style='color:green;'>(Correct)</span>" :'')+'</div>');
}

var loadQuizQuestion = function(z, question){
    $('#course-questions').append('<div class="question_nameLer"> <h5>Question '+z+'</h5> <hr> <div class="question_title"> <h6>'+question.title+'?</h6> '+(question && question.thumbnail ? '<img src="/static/course/content/thumbnail/'+question.thumbnail+'" class="img-fluid">' : '')+' <div class="optionname" id="question-option-'+question.id+'">  </div> </div> </div>');
    if(question.CourseQuizQuestionOptions && question.CourseQuizQuestionOptions.length > 0){
       var i=1;
        question.CourseQuizQuestionOptions.forEach(function(option) {
            loadQuizQuestionOption(question.id, option,i);
            ++i;
        });
    }
}
var loadQuiz = function(lectureId, lectureData){
    $('#all-hide-overview').hide();
    $('#videotitle').hide();
    $('#videodesc').hide();
    $('#submitquiz').show();
    $('#quiz').html('').html(' <div class="question_combine" id="course-questions"> </div>');
    if(lectureData && lectureData.length){
        var data = lectureData;
        questionData = [];
        questionc = data.length;
        for(z = 0; z < data.length; z++){
            if(data[z] && data[z].CourseQuizQuestion){
                loadQuizQuestion((z + 1), data[z].CourseQuizQuestion); 
                questionData.push(data[z]);     
            }
        }
    }
}

var loadFileUsingType = function(type, lectureData) {
    if(type == 'video' && lectureData){       
        $('#video1').attr('src', (lectureData.name ? '/static/course/content/'+lectureData.name : "/webnair.mp4"));
        $('#video1_html5_api').attr('src', (lectureData.name? '/static/course/content/'+lectureData.name :"/webnair.mp4"));
        $('#video1').show();
    }else if(type == 'pdf' && lectureData){
        $('#iframe11').attr('src', (lectureData.name? '/static/course/content/'+lectureData.name+'#toolbar=0' :"http://pdfviewer.softgateon.net/"));
        $('#pdf').show();
    }else if((type == 'doc' || type == 'ppt' || type == 'xls') && lectureData){
        $('#iframe11').attr('src', (lectureData.name? 'https://view.officeapps.live.com/op/embed.aspx?src='+window.origin+'/static/course/content/'+lectureData.name :"http://pdfviewer.softgateon.net/"));
        $('#pdf').show();
    }else{
        if(lectureData && lectureData.CourseUserQuizDetails){
            var d = lectureData.CourseUserQuizDetails[0];
            if(d && d.status) passFailStatus(lectureData.id, d.percent)
            else loadQuiz(lectureData.id, lectureData.CourseLectureQuestions);
        }else loadQuiz(lectureData.id, lectureData.CourseLectureQuestions);
        $('#quiz').show();
    }
}

var clearContent = function() {
    $('#sectionname').text('');
    $('#video1').hide();
    $('#pdf').hide();
    $('#quiz').hide();
    $('#video1_html5_api').removeAttr('src');
    $('#iframe11').removeAttr('src');
    $('#quiz').html('');
    $('#file-type').val('');
    $('#videotitle').text('').show();
    $('#videodesc').text('').show();
    $('#submitquiz').hide();
    $('#all-hide-overview').show();
}

var stopLecture = function() {
    if (videoPlayer)
        videoPlayer.pause();
}

var loadContent = function(id, sectionname, type) {
    clearContent();
    lectureId = id;
    var lectureData = fullLecture[lectureId];
    if(type == 'video') {
        loadFileUsingType(type, lectureData.Content);
        renderVideo();
    } else if(type == 'pdf' || type == 'doc' || type == 'ppt' || type == 'xls') {
        loadFileUsingType(type, lectureData.Content);
        stopLecture();
    }else if(type == 'quiz'){
        loadFileUsingType(type, lectureData);
        stopLecture()
    }
    $('#file-type').val(type);
    $('#sectionname').text(sectionname);
    $('#videotitle').text(lectureData.title);
}

var loadSectionList = function(idx, section) {
    var lectures = section.CourseSectionLectures;
    if(section.CourseSectionLectures.length > 0){
        $('#sectionlist').append('<div class="card"> <a data-toggle="collapse" data-target="#collapse'+idx+'"> <div class="card-header" id="headingOne"> <h5 class="mb-0"> Section '+idx+' : '+section.name+'</h5> </div> </a> <div id="collapse'+idx+'" class="collapse '+(idx == 1 ? 'show': '')+'" aria-labelledby="headingOne" data-parent="#accordion"> <div class="card-body"> <ul class="list-group list-group-flush"> '+loadlLectureList(section.name, lectures)+'</ul> </div> </div> </div>')
    }
}

var clearSectionList = function() {
    $('#sectionlist').html('');
    $('#lecturelist').html('');
    $('#coursename').html('');
    $('.course_name').html('');

}

var loadSectionLectures = function() { 
    var skills = [];
    api.course.previewCourse({id: page.courseId}, function(success){
        if(success){
            clearSectionList();
            if(success && success.course){
                success.course.CourseSkills.forEach(function(skill) {
                    var skillname = skill.Skill.name;
                        skills.push(skillname);
                    });
                    $('#coursename').html(success.course.name);
                    $('.course_name').html(success.course.name);
                    $(".page-title").html('Course: '+success.course.name);
                if(success.course.description){
                    $('.p_desc').css('display','block')
                    $('.show_description').html(success.course.description);
                }
                $('.show_course_skills').html(skills.toString());
                $('.show_lang').html(success.course.Language.name);
                if(success.course.CourseSections){
                    var section = success.course.CourseSections;
                    for(var i = 0; i < section.length; i++){
                        loadSectionList((i+1), section[i]);
                    }
                    if(page.type == 'streaming' && section[0] && section[0].CourseSectionLectures && section[0].CourseSectionLectures[0]){
                        var data = section[0].CourseSectionLectures[0];
                        loadContent(data.id, section[0].name,  data.type.toLowerCase())
                    }
                    $('.show_lecture_count').html('').html(setLectureCount);
                }
            }
        }
    })
}

var S3fe43dG = function() {
    $('#video1').bind('contextmenu',function() { return false; });
    window.onload = function() {
        document.addEventListener("contextmenu", function(e){
          e.preventDefault();
        }, false);
        document.addEventListener("keydown", function(e) {
            if (e.ctrlKey && e.shiftKey && e.keyCode == 73) 
                disabledEvent(e);
            if (e.ctrlKey && e.shiftKey && e.keyCode == 74) 
                disabledEvent(e);
            if (e.keyCode == 83 && (navigator.platform.match("Mac") ? e.metaKey : e.ctrlKey)) 
                disabledEvent(e);
            if (e.ctrlKey && e.keyCode == 85) 
                disabledEvent(e);
            if (event.keyCode == 123) 
                disabledEvent(e);
        }, false);
        function disabledEvent(e){
            if (e.stopPropagation)
                e.stopPropagation();
            else if (window.event)
                window.event.cancelBubble = true;
            e.preventDefault();
            return false;
        }
    };
}

$(document).ready(function() {
    S3fe43dG();
    $('#streaming').show();
    loadSectionLectures();
});
