var clearFreeTrial = function(){
    $('#error_fname').html('').addClass('d-none');
    $('#error_lname').html('').addClass('d-none');
    $('#error_email').html('').addClass('d-none');
    $('#error_password').html('').addClass('d-none');
    $('#error_cpassword').html('').addClass('d-none');
}

var validate = function(){
    clearFreeTrial();
    var data = new Object();
    var error = 0;
    data.firstName = sanitize($('#fname').val());
    if(data.firstName.length == 0){
        $('#error_fname').html('First Name is required field').removeClass('d-none');
        error = 1;
    }
    data.lastName = sanitize($('#lname').val());
    if(data.lastName.length == 0){
        $('#error_lname').html('Last Name is required field').removeClass('d-none');
        error = 1;
    }
    data.email = sanitize($('#email').val());
    if(data.email.length == 0){
        $('#error_email').html('Business Email is required field').removeClass('d-none');
        error = 1;
    }else if(!validateEmail(data.email)){
        $('#error_email').html('Business Email is Invalid').removeClass('d-none');
        error = 1;
    }
    data.password = sanitize($('#password').val());
    if(data.password.length == 0){
        $('#error_password').html('Password is required field').removeClass('d-none');
        error = 1;
    }
    data.confhash = sanitize($('#password-confirm').val());
    if(data.confhash.length == 0){
        $('#error_cpassword').html('Confirm password is required field').removeClass('d-none');
        error = 1;
    }
    if(error == 1)
        return false;
    return data;
}

var register = function(){
    var data = validate();
    if(data){
        data.source = 'Free Trial';
        data.URL = document.referrer?document.referrer:" ";
        showLoader();
        api.auth.free(data, function(data){
            hideLoader();
            showSuccess('Verification link sent to your provided email.');
            setTimeout(function() {
                window.location = '/verify';
            },1000);
        }, function (err) {
            hideLoader();
            clearFreeTrial();
            if(err && err.details){
                $('.toast-box').hide();
                if(err.details[0].context.key == 'password')
                    $('#error_password').html(err.details[0].message).removeClass('d-none');
                if(err.details[0].context.key == 'confhash')
                    $('#error_cpassword').html(err.details[0].message).removeClass('d-none');
            }
            if(err.errors){
                $('#error_email').html(err.errors[0]).removeClass('d-none');
            }
        });
    }
}

$(document).ready(function(){
    $('#register').on('click', function(){
        register();
        return false;
    });
    var dataAllInputs  = document.getElementsByTagName("input");
    for (var i = 0; i < dataAllInputs.length; i++) 
        dataAllInputs[i].setAttribute('autocomplete', 'off');
});