import { db } from '../../../../models';

var countSession = (simulationId) => {
    var data = {};
    return db.Session.count({
        where: {status: "Email Sent", simulationId: simulationId}
    })
    .then(count => {
        data['Email Sent'] = count;
        return db.Session.count({
            where: {status: "Pending", simulationId: simulationId}
        })  
    })
    .then(count => {
        data['Pending'] = count;
        return db.Session.count({
            where: {status: "Error", simulationId: simulationId}
        })  
    })
    .then(count => {
        data['Error'] = count;
        return data;
    })
    .catch(err => {
        console.log(err);
    })
}

export default {
    async index(req, res, next) {
        return res.render('campaign-list');
    },
    async campaign(req, res, next) {
        var campaignId = req.params.id;
        if(req.params.id == 0){
            return res.render('run-campaign');
        }else{
            db.Simulation.findOne({include: [{ model: db.Campaign, where: { id: campaignId, companyId: req.user.companyId }, required: true }], })
            .then(simulation => {
                if (simulation) {
                    return db.Session.count({where : {simulationId : simulation.id}}).then(r => [r, simulation])
                }else return [false,false];
            })
            .then(([session, simulation]) => {
                if(simulation)
                    return countSession(simulation.id).then(r => [session, r]);
                else return [false, false]
            })
            .then(([totalSession, campaignCount]) => {
                if(!totalSession && !campaignCount){
                    return res.render('404'); 
                }else{
                    if(campaignCount){
                        var EmailSent = (campaignCount['Email Sent']/totalSession)*100;
                        var Pending = (campaignCount['Pending']/totalSession)*100;
                        var Error1 = (campaignCount['Error']/totalSession)*100;
                        return res.render('campaign-result', {EmailSent: EmailSent, Pending: Pending, Error: Error1, id: req.params.id});
                    } 
                    else
                        throw new RequestError('No Data found');
                }
            })
            .catch(err => { 
                console.log(err)
                next(err);
            })
        }
    },
    
};  