import express from 'express';
import { jwtStrategy } from '../../../../middleware/strategy';
import courseanalyticController from './courseanalytic.controller';
import { userPermission} from '../../../../middleware/userPermission';
import { userImplant } from '../../../../middleware/auth';

export const courseanalyticRouter = express.Router();
courseanalyticRouter.route('/analytic/list').get(jwtStrategy, userImplant ,userPermission('course-analytic-read'),courseanalyticController.index);
courseanalyticRouter.route('/analytic/:id').get(jwtStrategy, userImplant ,userPermission('course-analytic-list'),courseanalyticController.courseSingle);
courseanalyticRouter.route('/analytic/student-list/:id').get(jwtStrategy ,userImplant ,userPermission('course-analytic-student-list'),courseanalyticController.studentList);
courseanalyticRouter.route('/analytic/student-quiz-result/:id').get(jwtStrategy ,userImplant ,userPermission('course-analytic-student-list'),courseanalyticController.studentQuizResult);
courseanalyticRouter.route('/analytic/lecture-list/:id').get(jwtStrategy ,userImplant ,userPermission('course-analytic-student-list'),courseanalyticController.lectureList);
courseanalyticRouter.route('/analytic/single-student').get(jwtStrategy,userImplant , userPermission('course-analytic-student-read'),courseanalyticController.singleStudent);
courseanalyticRouter.route('/analytic/departments-list').get(jwtStrategy, userImplant ,userPermission('course-analytic-department-list'),courseanalyticController.department);