import express from 'express';
import { jwtStrategy } from '../../../../middleware/strategy';
import { userImplant } from '../../../../middleware/auth';
import iamUserController from './iam-user.controller';
import { userPermission } from '../../../../middleware/userPermission';

export const iamUserRouter = express.Router();

iamUserRouter.route('/users').get( jwtStrategy, userImplant,userPermission('user-read'),iamUserController.iamUser);
iamUserRouter.route('/users/:id').get(jwtStrategy, userImplant,userPermission('user-policy-read'), iamUserController.iamUserEdit)
iamUserRouter.route('/addPolicy/:id').get(jwtStrategy, userImplant,userPermission('user-policy-assign'), iamUserController.addPermission);
iamUserRouter.route('/addUser').get(jwtStrategy, userImplant,userPermission('user-write'), iamUserController.addUser);

