import express from 'express';
import { jwtStrategy } from '../../../../middleware/strategy';
import quizController from './quiz.controller';
import { userPermission } from '../../../../middleware/userPermission';
import { userImplant } from '../../../../middleware/auth';

export const quizRouter = express.Router();
quizRouter.route('/assessment/list').get(jwtStrategy , userImplant,userPermission('quiz-list') , quizController.index);
quizRouter.route('/assessment/create').get(jwtStrategy , userImplant,userPermission('quiz-write') ,quizController.createQuiz);
quizRouter.route('/assessment/create/:id').get(jwtStrategy , userImplant,userPermission('quiz-write') , quizController.editQuiz);