import { db } from "../../../../models";

export default {
    async index(req, res, next) {
        return res.render('assessment');
    },

    async userList(req, res, next) {
        db.Quiz.findOne({ where :{ id:req.params.id, status: 'Published', companyId: req.user.companyId } })
        .then(r => {
            if(r) return res.render('user-assessment-result', { 'id':req.params.id } );
            else  return res.status(404).send('Quiz not found'); 
        })
    },

    async assessmentResult(req, res, next) {
        if(req.params.id && req.params.sKey){
            db.Quiz.findOne({ where: {id:req.params.id } })
            .then(quiz => {
                if(quiz) return db.Session.findOne({ where: { sessionKey: req.params.sKey }});
                else return res.status(404).send('Invalid quiz received!'); 
            })
            .then(session => {
                if(session) return db.MemberCourse.findOne({ where: {quizId:req.params.id, sessionId:session.id  } });
                else return res.status(404).send('Invalid learner received!'); 
            })
            .then(memberCourse => {
                if(memberCourse){
                    if(memberCourse.completedAt == null) return res.redirect('my-assessments/guidelines/'+req.params.id+'/'+req.params.sKey);
                    else return res.render('assessment-result', {'id':req.params.id, 'sKey':req.params.sKey});
                }else return res.status(404).send('Invalid learner received!'); 
            })
        }else return res.status(404).send('Invalid data received!'); 
    },
};