import express from 'express';
import { jwtStrategy } from '../../../../middleware/strategy';
import resultController from './result.controller';
import { userPermission} from '../../../../middleware/userPermission';
import { userImplant } from '../../../../middleware/auth';

export const resultRouter = express.Router();
resultRouter.route('/result/list').get(jwtStrategy, userImplant ,userPermission('course-analytic-read'),resultController.index);  
resultRouter.route('/result/user-assessment-result/:id').get(jwtStrategy ,userImplant ,userPermission('course-analytic-student-list'),resultController.userList);
resultRouter.route('/my-assessments/result/:id/:sKey').get(jwtStrategy ,userImplant ,userPermission('assessment-result'),resultController.assessmentResult);
